/***************************************************************************
                          adressbuch.cpp  -  description
                             -------------------
    begin                : Mon Jul 10 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "adressbuch.h"
#include "qtextstream.h"
#include <kapp.h>
#include "global.h"

extern DATEN *daten;

extern bool debugMode;

adressBook::adressBook() : QWidget() {

if (debugMode == true ) cout << "adressBook-Klasse\n";

callRemove.setAutoDelete( true );

QString fileTmp = daten->workDir;

fileTmp.append("/adressbook");

adressFile = new QFile( fileTmp );

cout << "adressFile " << fileTmp << "\n";

resize( 400, 300 );

eintraege = new QListView( this );

QObject::connect( eintraege, SIGNAL(doubleClicked(QListViewItem *)),this, SLOT( slotSelectedCall(QListViewItem*)));

eintraege->setAllColumnsShowFocus( true );

eintraege->move( 5, 5 );
eintraege->addColumn( i18n("Rufzeichen"), 0 );

eintraege->setColumnWidth( 0, 100 );
eintraege->addColumn( i18n("Bemerkungen"), 1 );

call = new QLineEdit( this );

call->resize( 100, 20 );

extras = new QLineEdit( this );

ok = new QPushButton( i18n( "OK" ), this );

QObject::connect( ok, SIGNAL( clicked()), this, SLOT( okPressed()) );

abort = new QPushButton( i18n( "Abbrechen" ), this );

QObject::connect( abort, SIGNAL( clicked()), this, SLOT( killMe()) );

insert = new QPushButton( i18n( "Hinzufgen" ), this );

QObject::connect( insert, SIGNAL( clicked()), this, SLOT( insertStation() ));

remove = new QPushButton( i18n( "Entfernen" ), this );

QObject::connect( remove, SIGNAL( clicked()), this, SLOT( removePressed() ) );

readFile();

show();
}

//____________________________________________________________________________

adressBook::~adressBook() {

}

//_____________________________________________________________________________

void adressBook::readFile() {

QString tmp, tmp2;

if( adressFile->open( IO_ReadOnly ) ) {

	QTextStream ts( adressFile );

	while ( !ts.eof() ) {

		tmp  = ts.readLine();

		if( !tmp.isEmpty() ) {

			if (debugMode == true )	cout << tmp << "_\n";

			tmp2 = tmp.left( tmp.find(" ") );
			tmp.remove( 0, tmp.find(" ")+1 );
			new QListViewItem( eintraege, tmp2, tmp );

		}

	}
adressFile->close();
}
}

//_____________________________________________________________________________________

void adressBook::insertStation() {

QString tmp1 = call->text();
QString tmp2 = extras->text();

if( !tmp1.isEmpty() && !tmp2.isEmpty() ) {

	callInsert.append( call->text() );
	callInsert.append(" ");
	callInsert.append( extras->text() );
	callInsert.append("\n");

	new QListViewItem( eintraege, call->text(), extras->text() );

	call->clear();
	extras->clear();
}
}

//____________________________________________________________________________

void adressBook::removePressed() {

QListViewItem *cI = eintraege->currentItem();

if( cI != NULL ) {

	QString line = cI->text( 0 );
	line.append( " " );
	line.append( cI->text( 1 ) );

	if (debugMode == true )	cout << "line " << line << "_\n";

	callRemove.append( new QString( line ) );

	delete cI;
}
}


//_____________________________________________________________________________


void adressBook::okPressed() {

if ( !callInsert.isEmpty() ) {

	if( adressFile->open( IO_WriteOnly | IO_Append ) ) {

		adressFile->writeBlock( callInsert, callInsert.length() );	

		new QListViewItem( eintraege, call->text(), extras->text() );

		call->clear();
		extras->clear();
		adressFile->close();
	}
}

if ( callRemove.count() > 0 ) {

	QString tmp, fullFile;

//datei backupen..
	if( adressFile->open( IO_ReadOnly ) ) {

		QTextStream ts( adressFile );

		while ( !ts.eof() ) {

			tmp = ts.readLine();

			if( !tmp.isEmpty() ) {

			 fullFile.append( tmp );
			 fullFile.append( "\n" );
			}

		}
	adressFile->close();
	}

//das entsprechende loeschen...

	QString *current;

	current =	callRemove.first();


	while ( (uint) callRemove.at() <= callRemove.count() ) {

	 	current = callRemove.current();

	 	if( fullFile.find( *current ) != -1 ) {
			if (debugMode == true )	cout << "Find " << *current << "\n";
			fullFile.remove( fullFile.find( *current ), current->length()+1 );	//eintrag loeschen..
		}

	 	callRemove.next();
	}


// bearbeiteten string wieder in die datei geben ...

	if( adressFile->open( IO_WriteOnly ) ) {

		adressFile->writeBlock( fullFile, fullFile.length() );
		adressFile->close();
	}


}

if( eintraege->currentItem() != NULL )
	selectedCall( eintraege->currentItem()->text( 0 ) );

killMe();
}


//_______________________________________________________________________


void adressBook::slotSelectedCall( QListViewItem *cI ) {

if( cI != NULL )
	selectedCall( cI->text( 0 ) );

}


//_______________________________________________________________________


// hehe, etwas eigensinnige resizemethode ;))
void adressBook::resizeEvent( QResizeEvent * ) {

eintraege->resize( width() -10, height() - 65 );
eintraege->setColumnWidth( 1, width() - 110 );
call->move( 5, eintraege->height() + 8 );
extras->move( 105, eintraege->height() + 8 );
extras->resize( width() - 110, 20 );

ok->resize( (width() -10) / 4, 25 );
abort->resize( (width() -10) / 4, 25 );
insert->resize( (width() -10) / 4, 25 );
remove->resize( (width() -10) / 4, 25 );

ok->move( 5, eintraege->height() +33 );
abort->move( ok->width() +5, eintraege->height() +33 );
insert->move( ok->width()*2+5, eintraege->height() +33 );
remove->move( ok->width()*3+5, eintraege->height() +33 );
}


//__________________________________________________________________________


void adressBook::killMe() {
delete eintraege;
delete ok;
delete abort;
delete insert;
delete remove;
delete call;
delete extras;
delete this;
}