/***************************************************************************
                          configdlg.cpp  -  description
                             -------------------
    begin                : Tue Jul 11 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kapp.h>
#include <kfontdialog.h>
#include <qdir.h>

#include "configdlg.h"
#include "global.h"

extern DATEN *daten;

extern bool debugMode;

configDlg::configDlg( QWidget *parent=0, const char *name=0, bool modal=false, WFlags f=0)
		: QTabDialog( parent, name, modal, f ) {

if (debugMode == true ) cout << "configDlg-Klasse\n";

editFont = daten->editorFont;

resize( 390, 380 );

addTab( ax25Wid = new QWidget(this), i18n("AX25") );
addTab( mailerWid = new QWidget(this), i18n("Mailer") );
addTab( parsingWid = new QWidget(this), i18n ("Parsing") );
addTab( passwordWid = new QWidget(this), i18n("Passwort") );
addTab( downloadWid = new QWidget(this), i18n("Download") );

createAx25Widget();
createMailerWidget();
createParsingWidget();
createPasswordWidget();
createDownloadWidget();

setCancelButton( i18n("Abbrechen") );
setApplyButton( i18n("bernehmen") );

QObject::connect( this, SIGNAL(applyButtonPressed()), this, SLOT(applyPressed()));

show();
}

configDlg::~configDlg() {

}

//_____________________________________________________________________________

// die elemente im ax25-tab
void configDlg::createAx25Widget() {

QGroupBox *myCallBox = new QGroupBox( i18n("Ihr Rufzeichen"), ax25Wid );

myCallBox->move( 10, 10 );

myCallBox->resize( 130, 50 );

myCallEdit = new QLineEdit( myCallBox );
myCallEdit->move( 5, 17 );
myCallEdit->resize( myCallBox->width() -10, 25 );
myCallEdit->setText( daten->AX25myCall );

QGroupBox *portBox = new QGroupBox( i18n("AX.25-Port"), ax25Wid );

portBox->move( 170, 10 );
portBox->resize( 130, 50 );

portEdit = new QLineEdit( portBox );
portEdit->move( 5, 17 );
portEdit->resize( myCallBox->width() -10, 25 );
portEdit->setText( daten->ax25Port );

QGroupBox *destCallBox = new QGroupBox( i18n("Mailbox-Call"), ax25Wid );

destCallBox->move( 10, 70 );
destCallBox->resize( 130, 50 );

destCallEdit = new QLineEdit( destCallBox );
destCallEdit->move( 5, 17 );
destCallEdit->resize( myCallBox->width() -10, 25 );
destCallEdit->setText( daten->destCall );


QGroupBox *ax25pathBox = new QGroupBox( i18n("Digipeater"), ax25Wid );

ax25pathBox->move( 170, 70 );
ax25pathBox->resize( 130, 50 );

pathEdit = new QLineEdit( ax25pathBox );
pathEdit->move( 5, 17 );
pathEdit->resize( myCallBox->width() -10, 25 );
pathEdit->setText( daten->ax25Path );


QGroupBox *MBTypeBox = new QGroupBox( i18n("Mailbox-Typ"), ax25Wid );

MBTypeBox->move( 10, 130 );
MBTypeBox->resize( 130, 50 );

MBType = new QComboBox( MBTypeBox );
MBType->move( 5, 17 );
MBType->resize( myCallBox->width() -10, 25 );
MBType->insertItem( "dp" );
MBType->insertItem( "baycom" );

if ( daten->boxTyp == "dp" )	MBType->setCurrentItem( 0 );
else	MBType->setCurrentItem( 1 );

}


//_______________________________________________________________________________


// elemente in Mailer-tab
void configDlg::createMailerWidget() {

QGroupBox *firstCmdsBox = new QGroupBox( i18n("Kommandos nach erfolgten Connect"), mailerWid );

firstCmdsBox->move( 10, 10 );
firstCmdsBox->resize( 350, 50 );

firstCmdsEdit = new QLineEdit( firstCmdsBox );
firstCmdsEdit->move( 5, 17 );
firstCmdsEdit->resize( firstCmdsBox->width() -60, 25 );

QPushButton *but = new QPushButton( "Info", firstCmdsBox );
but->move( firstCmdsEdit->width() + 10, 17 );
but->resize( 40, 25 );

QObject::connect( but, SIGNAL(clicked()), this, SLOT(infoFirstCmd()));

firstCmdsEdit->setText( daten->firstCmds );

QGroupBox *checkCmdsBox = new QGroupBox( i18n("Mail-Check Kommando"), mailerWid );

checkCmdsBox->move( 10, 70 );
checkCmdsBox->resize( 350, 50 );

checkCmdsEdit = new QLineEdit( checkCmdsBox );
checkCmdsEdit->move( 5, 17 );
checkCmdsEdit->resize( checkCmdsBox->width() -60, 25 );

QPushButton *but2 = new QPushButton( "Info", checkCmdsBox );
but2->move( checkCmdsEdit->width() + 10, 17 );
but2->resize( 40, 25 );

QObject::connect( but2, SIGNAL( clicked()), this, SLOT( infoCheckCmd()));

checkCmdsEdit->setText( daten->checkComand );


QGroupBox *fontBox = new QGroupBox( i18n("Editor-Font"), mailerWid );


fontBox->move( 10, 130 );
fontBox->resize( 130, 50 );

QPushButton *fontBut = new QPushButton( i18n( "Font-Auswahl" ), fontBox );
fontBut->move( 5, 17 );
fontBut->resize( fontBox->width() -10, 25 );

QObject::connect( fontBut, SIGNAL(clicked()), this, SLOT(createFontDialog()));


QGroupBox *autoReturnBox = new QGroupBox( i18n("auto. Zeilen-Umbruch"), mailerWid );

autoReturnBox->move( 150, 130 );
autoReturnBox->resize( 150, 50 );

autoReturn = new QSpinBox( 0, 250, 1, autoReturnBox );
autoReturn->setValue( daten->autoReturn );
autoReturn->move( 5, 17 );
autoReturn->resize( 50, 25 );

QLabel *autoReturnTxt = new QLabel ( i18n("Zeichen"), autoReturnBox );
autoReturnTxt->move( 70, 15 );
autoReturnTxt->resize( 50, 25 );

QGroupBox *mailAbschlussBox = new QGroupBox( i18n("Mail-Abschlu"), mailerWid );

mailAbschlussBox->move( 10, 190 );
mailAbschlussBox->resize( 350, 100 );

mailAbschluss = new QMultiLineEdit( mailAbschlussBox );

mailAbschluss->move( 5, 17 );
mailAbschluss->resize( mailAbschlussBox->width() -10, mailAbschlussBox->height() - 22 );

mailAbschluss->setText( daten->mailAbschlussTxt );
}


//______________________________________________________________________________


// elemente in Parsing-tab
void configDlg::createParsingWidget() {

QGroupBox *listHeaderBox = new QGroupBox( i18n("List-Header"), parsingWid );

listHeaderBox->move( 10, 5 );
listHeaderBox->resize( 350, 40 );

listHeader = new QComboBox( true, listHeaderBox );

listHeader->move( 5, 14 );
listHeader->resize( listHeaderBox->width() -57, listHeaderBox->height() - 18 );

listHeader->insertItem( "Nr. Von    Datum    UTC    Bytes  Betreff" );
listHeader->insertItem( "Nr Call   Datum    Zeit   Bytes  Titel" );
listHeader->setEditText( daten->listHeader );

QPushButton *but1 = new QPushButton( "info", listHeaderBox );
but1->move( listHeader->width() + 10, 14 );
but1->resize( 40, listHeader->height() );

QObject::connect( but1, SIGNAL( clicked()), this, SLOT( infoListHeader()));

QGroupBox *checkHeaderBox = new QGroupBox( i18n("Check-Header"), parsingWid );

checkHeaderBox->move( 10, 45 );
checkHeaderBox->resize( 350, 40 );

checkHeader = new QComboBox( true, checkHeaderBox );

checkHeader->move( 5, 14 );
checkHeader->resize( checkHeaderBox->width() -57, checkHeaderBox->height() - 18 );

checkHeader->insertItem( "# Absender Rubrik   Nr. Datum    @BBS   Bytes #LT Titel" );
checkHeader->insertItem( "# Call     File     Nr.  Datum   @MBX   Bytes #LT Titel" );
checkHeader->setEditText( daten->checkHeader );

QPushButton *but2 = new QPushButton( "info", checkHeaderBox );
but2->move( checkHeader->width() + 10, 14 );
but2->resize( 40, checkHeader->height() );

QObject::connect( but2, SIGNAL( clicked()), this, SLOT( infoCheckHeader()));

QGroupBox *listGenreRowBox = new QGroupBox( i18n("Rubrikangabe vor List"), parsingWid );

listGenreRowBox->move( 10, 85 );
listGenreRowBox->resize( 350, 40 );

listGenreRow = new QComboBox( true, listGenreRowBox );

listGenreRow->move( 5, 14 );
listGenreRow->resize( listGenreRowBox->width() -57, listGenreRowBox->height() - 18 );

listGenreRow->insertItem( "Info-File:" );
listGenreRow->insertItem( "Inhaltsverzeichnis fuer" );
listGenreRow->setEditText( daten->listGenreRow );

QPushButton *but3 = new QPushButton( "info", listGenreRowBox );
but3->move( listGenreRow->width() + 10, 14 );
but3->resize( 40, listGenreRow->height() );

QObject::connect( but3, SIGNAL( clicked()), this, SLOT( infoListGenreRow()));



QGroupBox *boxPromptBox = new QGroupBox( i18n("Box-Prompt"), parsingWid );

boxPromptBox->move( 10, 125 );
boxPromptBox->resize( 350, 40 );

boxPrompt = new QComboBox( true, boxPromptBox );

boxPrompt->move( 5, 14 );
boxPrompt->resize( boxPromptBox->width() -57, boxPromptBox->height() - 18 );

boxPrompt->insertItem( "DG2YLP de DB0PKE>" );
boxPrompt->insertItem( "Help Dir Read Erase Check REPly Send Alter Quit" );
boxPrompt->setEditText( daten->boxPrompt );

QPushButton *but4 = new QPushButton( "info", boxPromptBox );
but4->move( boxPrompt->width() + 10, 14 );
but4->resize( 40, boxPrompt->height() );

QObject::connect( but4, SIGNAL( clicked()), this, SLOT( infoBoxPrompt()));


QGroupBox *mailBeginningBox = new QGroupBox( i18n("Anfang einer Nachricht"), parsingWid );

mailBeginningBox->move( 10, 165 );
mailBeginningBox->resize( 350, 40 );

mailBeginning = new QComboBox( true, mailBeginningBox );

mailBeginning->move( 5, 14 );
mailBeginning->resize( mailBeginningBox->width() -57, mailBeginningBox->height() - 18 );

mailBeginning->insertItem( "Read:" );
mailBeginning->insertItem( "Subj:" );
mailBeginning->setEditText( daten->mailBeginning );

QPushButton *but5 = new QPushButton( "info", mailBeginningBox );
but5->move( mailBeginning->width() + 10, 14 );
but5->resize( 40, mailBeginning->height() );

QObject::connect( but5, SIGNAL( clicked()), this, SLOT( infoMailBeginning()));


QGroupBox *mailStoredBox = new QGroupBox( i18n("Nachricht wurde gespeichert"), parsingWid );

mailStoredBox->move( 10, 205 );
mailStoredBox->resize( 350, 40 );

mailStored = new QComboBox( true, mailStoredBox );

mailStored->move( 5, 14 );
mailStored->resize( mailStoredBox->width() -57, mailStoredBox->height() - 18 );

mailStored->insertItem( "Nachricht ist gespeichert" );
mailStored->insertItem( ") abgespeichert." );
mailStored->setEditText( daten->mailReceived );

QPushButton *but6 = new QPushButton( "info", mailStoredBox );
but6->move( mailStored->width() + 10, 14 );
but6->resize( 40, mailStored->height() );

QObject::connect( but6, SIGNAL( clicked()), this, SLOT( infoMailStored()));


QGroupBox *mailErasedBox = new QGroupBox( i18n("Nachricht wurde gelscht"), parsingWid );

mailErasedBox->move( 10, 245 );
mailErasedBox->resize( 350, 40 );

mailErased = new QComboBox( true, mailErasedBox );

mailErased->move( 5, 14 );
mailErased->resize( mailErasedBox->width() -57, mailErasedBox->height() - 18 );

mailErased->insertItem( "Die Nachrichten sind geloescht!" );
mailErased->insertItem( "Nachricht wird geloescht." );
mailErased->setEditText( daten->erasedMail );

QPushButton *but7 = new QPushButton( "info", mailErasedBox );
but7->move( mailErased->width() + 10, 14 );
but7->resize( 40, mailErased->height() );

QObject::connect( but7, SIGNAL( clicked()), this, SLOT( infoMailErased()));

}


// password-Tab_________________________________________________________________


void configDlg::createPasswordWidget() {

PWActivated = new QCheckBox( i18n("Passwort verwenden"), passwordWid );
PWActivated->move( 10, 10 );
PWActivated->resize( 150, 25 );

PWActivated->setChecked( daten->passwordActive );

QGroupBox *passwdBox = new QGroupBox( i18n("Passwort-Einstellungen"), passwordWid );

passwdBox->move( 10, 50 );
passwdBox->resize( 350, 100 );

md5Box = new QCheckBox( i18n("MD5"), passwdBox );
md5Box->move( 10, 15 );
md5Box->setChecked( true ); // temproraer..

QGroupBox *passwdEditBox = new QGroupBox( i18n("Passwort"), passwdBox );

passwdEditBox->move( 10, 53 );
passwdEditBox->resize( 328, 40 );

passwordEdit = new QLineEdit( passwdEditBox );

passwordEdit->move( 5, 14 );
passwordEdit->resize( passwdEditBox->width() -10, passwdEditBox->height() - 18 );

passwordEdit->setText( daten->password );

QObject::connect( PWActivated, SIGNAL( toggled(bool) ),
									this, SLOT( slotPWActivated(bool) ) );

slotPWActivated( daten->passwordActive );

}

void configDlg::slotPWActivated( bool toggle ) {

passwordEdit->setEnabled( toggle );
md5Box->setEnabled( toggle );
}

// DownloadTab _________________________________________________________________

void configDlg::createDownloadWidget() {

QGroupBox *pathEditBox = new QGroupBox( i18n("7Plus-Speicher-Pfad"), downloadWid );

pathEditBox->move( 10, 23 );
pathEditBox->resize( 328, 50 );

downEdit = new QLineEdit( pathEditBox );

downEdit->move( 5, 15 );
downEdit->resize( pathEditBox->width() -10, pathEditBox->height() - 22 );

downEdit->setText( daten->downloadPath );


QGroupBox *pathEditBox2 = new QGroupBox( i18n("AutoBin-Speicher-Pfad"), downloadWid );

pathEditBox2->move( 10, 78 );
pathEditBox2->resize( 328, 50 );

downEdit2 = new QLineEdit( pathEditBox2 );

downEdit2->move( 5, 15 );
downEdit2->resize( pathEditBox2->width() -10, pathEditBox2->height() - 22 );

downEdit2->setText( daten->aDownloadPath );

}

//______________________________________________________________________________


void configDlg::createFontDialog() {

editFont = daten->editorFont;

KFontDialog::getFont( editFont );
}


//______________________________________________________________________________


void configDlg::applyPressed() {

bool alright=true;

QString tmp;

tmp = myCallEdit->text();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Kein MyCall angegeben!\n");
	alright=false;
}
else {
	daten->AX25myCall = tmp.lower();

	daten->myCall = daten->AX25myCall;
	if( daten->myCall.find( "-" ) != -1 ) daten->myCall.resize( daten->myCall.find( "-" )+1 ); //ssid muss wech :)
}

tmp = portEdit->text();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Kein Port angegeben!\n");
	alright=false;
}
else
	daten->ax25Port = tmp;


tmp = destCallEdit->text();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Keine Mailbox angegeben!\n");
	alright=false;
}
else
	daten->destCall = tmp;


tmp = pathEdit->text();

if( !tmp.isEmpty() ) daten->ax25Path = tmp;


daten->boxTyp = MBType->currentText();


tmp = firstCmdsEdit->text();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Kein Kommando nach Connect angegeben!\n");
}
else
	daten->firstCmds = tmp;


tmp = checkCmdsEdit->text();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Kein Check-Kommando angegeben!\n");
	alright=false;
}
else
  daten->checkComand = tmp;

daten->autoReturn = autoReturn->value();

daten->mailAbschlussTxt = mailAbschluss->text();


tmp = listHeader->currentText();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Keinen List-Header angegeben!\n");
	alright=false;
}
else
	daten->listHeader = tmp;


tmp = checkHeader->currentText();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Keinen Check-Header angegeben!\n");
	alright=false;
}
else
	daten->checkHeader = tmp;


tmp = listGenreRow->currentText();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Keine Rubrikangabe-vor-List-Text angegeben!\n");
	alright=false;
}
else
	daten->listGenreRow = tmp;


tmp = boxPrompt->currentText();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Kein Box-Prompt angegeben!\n");
	alright=false;
}
else
	daten->boxPrompt = tmp;


tmp = mailBeginning->currentText();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Keinen Mail-Anfang-Eintrag gefunden!\n");
	alright=false;
}
else
	daten->mailBeginning = tmp;


tmp = mailStored->currentText();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Keinen Mail-Gespeichert-Text angegeben!\n");
	alright=false;
}
else
	daten->mailReceived = tmp;


tmp = mailErased->currentText();

if( tmp.isEmpty() ) {
	QMessageBox::information( this, "PMC", "Keinen Mail-Gelscht-Text angegeben!\n");
	alright=false;
}
else
	daten->erasedMail = tmp;

daten->editorFont = editFont;


daten->passwordActive = PWActivated->isChecked();

if( daten->passwordActive ) {
// hier muss spaeter (sofern weitere passwort-arten reinkommen) noch die abfrage fuer passwort-typ eingesetzt werden.
	daten->password = passwordEdit->text();
}


QDir downDir( downEdit->text() );

if ( !downDir.exists() ) {
	if(	!downDir.mkdir( downEdit->text() ) ) {
		QMessageBox::information( this, "PMC", i18n("Kann das Speicher-Verzeichnis (Download) nicht erstellen!"));
  	alright = false;
	}
	else {
		daten->downloadPath = downEdit->text();
	}
}
else {
	daten->downloadPath = downEdit->text();
}





downDir.setPath( downEdit2->text() );

if ( !downDir.exists() ) {
	if(	!downDir.mkdir( downEdit2->text() ) ) {
		QMessageBox::information( this, "PMC", i18n("Kann das Speicher-Verzeichnis (Download) nicht erstellen!"));
  	alright = false;
	}
	else {
		daten->aDownloadPath = downEdit2->text();
	}
}
else {
	daten->aDownloadPath = downEdit2->text();
}





if ( alright == true ) daten->speicher_daten();		// daten speichern

if (debugMode == true ) cout << "applyPressed\n";
}

//______________________________________________________________________________


void configDlg::infoFirstCmd() {

QMessageBox::information( this, "PMC", i18n("Hier knnen Sie die Kommandos eingeben welche PMC
direkt nachdem Connect sendet. Normalerweise ist dieses
das Check-Kommando (c), aber man kann selbstverstndlich
auch das List-Kommando verwenden( z.B.: l linux ), wenn man
mehrere Kommandos benutzen will sollte man diese durch ein
Semikolon trennen!
Ein auflisten Ihres Mail-Verzeichnis ist nicht von nten, da
PMC dieses automatisch anfordert.\n
Bitte kombinieren Sie aber nicht das Check- mit dem List-Kommando!" ) );

}

void configDlg::infoCheckCmd() {

QMessageBox::information( this, "PMC", i18n("Hier knnen Sie die Kommandos eingeben, welche gesendet
werden, wenn man den MailCheck-Button anklickt (Brief&Fragezeichen).
blicherweise wird hier das Check-Kommando verwendet, aber Sie knnen
auch das List-Kommando (z.B. l linux) verwenden.\n
Mehrere Kommandos werden durch ein Semikolon getrennt!") );
}

void configDlg::infoListHeader() {
QMessageBox::information( this, "PMC", i18n("Mit List-Header ist die berschrift gemeint welche
am Anfang einer List-Liste steht. In der ComboBox
sind auch direkt 2 Beispiele fuer diese Zeilen drin,
welche in den meisten Fllen schon direkt funktionieren
drften! Der erste Eintrag in der ComboBox ist die Standart-Zeile
fr DP-Boxen und der zweite Eintrag ist die Standart-Zeile bei
Baycom-Boxen.") );
}

void configDlg::infoCheckHeader() {
QMessageBox::information( this, "PMC", i18n("Mit Check-Header ist die berschrift gemeint welche
am Anfang einer Check-Liste steht. In der ComboBox sind
ebenfalls direkt 2 Beispiele fuer diese Zeilen drin.
Der erste Eintrag der ComboBox ist fuer DP-Boxen und der zweite fr
Baycom-Boxen. Wenn ihre Box die Standart-Texte verwendet
sollten diese direkt funktionieren!") );
}


void configDlg::infoListGenreRow() {
QMessageBox::information( this, "PMC", i18n("Hiermit ist die Zeile gemeint, welche vor der
List-Mail-Liste (mit l <rubrik> initalisiert) die aktuelle
Rubrik angibt. In der ComboBox sind bereits 2 Standart-Zeilen
fr DP- und Baycom-Boxen vorhanden (die 1. fuer DP und die 2.
fr Baycom). Diese Sollten in der Regel funktionieren ;)") );

}

void configDlg::infoBoxPrompt() {
QMessageBox::information( this, "PMC", i18n("Dieser Eintrag sollte eigentlich klar sein.
Allerdings gibt es hier eine Besonderheit fuer Baycom-User.
Bei Baycom-Boxen MU noch ein Enter (Zeilenumbruch) am Ende erfolgen,
da es sonst zu Fehlern in der Status-Zeile kommt :(.\n
Die ComboBox enthlt mal wieder 2 Beispiel-Zeilen welche funktionieren
sollten (die erste Zeile, welche fuer DP-Boxen ist, sollte allerdings
an Ihr Call und Ihre HomeBBS angepat werden)") );
}

void configDlg::infoMailBeginning() {
QMessageBox::information( this, "PMC", i18n("Wenn PMC diesen Eintrag empfngt, fngt es
an den folgenden Text (bis zum Empfang des Boxpromptes)
in den RX-Editor zu schreiben.
Es sind auch hier direkt 2 Beispiele fr die DP- und
Baycom-Boxen in der ComboBox.
(Der erste Eintrag in der ComboBox ist fr DP-Boxen und
der zweite fuer Baycom-Boxen.") );
}

void configDlg::infoMailStored() {
QMessageBox::information( this, "PMC", i18n("Bitte tragen Sie hier den Text ein, welchen
die Box sendet, wenn eine Empfangene Nachricht gespeichert
wurde.\n
In der ComboBox sind 2 Beispiele, welche fr DP- und Baycom-
Boxen funktionieren sollten. (Der 1. Eintrag in der ComboBox
ist fr DP-Boxen und der 2. Eintrag fr Baycom-Boxen)") );
}

void configDlg::infoMailErased() {
QMessageBox::information( this, "PMC", i18n("Bitte tragen Sie hier den Text ein, welchen
die Box sendet, wenn Sie gerade eine Nachricht gelscht
haben.\n
In der ComboBox sind 2 Beispiele, welche fr DP- und Baycom-
Boxen funktionieren sollten. (Der 1. Eintrag in der ComboBox
ist fr DP-Boxen und der 2. Eintrag fr Baycom-Boxen)") );
}
