/***************************************************************************
                          configdlg.h  -  description
                             -------------------
    begin                : Tue Jul 11 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream.h>
#include <qwidget.h>
#include <qlineedit.h>
#include <qmultilinedit.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qmessagebox.h>
#include <qlabel.h>
#include <qgroupbox.h>
#include <qtabdialog.h>
#include <qcombobox.h>


class configDlg : public QTabDialog {

Q_OBJECT;

public:
	configDlg( QWidget *parent=0, const char *name=0, bool modal=false, WFlags f=0 );
	~configDlg();

private slots:
	void createAx25Widget();
	void createMailerWidget();
	void createParsingWidget();
	void createFontDialog();
	void createPasswordWidget();
	void createDownloadWidget();
	void slotPWActivated( bool );
	void applyPressed();

	void infoFirstCmd();
	void infoCheckCmd();
	void infoListHeader();
	void infoCheckHeader();
	void infoListGenreRow();
	void infoBoxPrompt();
	void infoMailBeginning();
	void infoMailStored();
	void infoMailErased();

private:
	QWidget *parsingWid, *mailerWid, *ax25Wid, *passwordWid, *downloadWid;
	QLineEdit *myCallEdit, *portEdit, *destCallEdit, *pathEdit;
	QLineEdit *firstCmdsEdit, *checkCmdsEdit, *downEdit;
	QLineEdit *downEdit2;
	QMultiLineEdit *mailAbschluss;
	QComboBox *MBType;
	QComboBox *listHeader, *checkHeader, *listGenreRow, *boxPrompt, *mailBeginning;
	QComboBox *mailStored, *mailErased;
	QCheckBox *PWActivated, *md5Box;
	QSpinBox *autoReturn;
	QLineEdit *passwordEdit;
	QFont editFont;
};