/***************************************************************************
                          dialogs.cpp  -  description
                             -------------------
    begin                : Tue Oct 3 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kapp.h>
#include <qgroupbox.h>
#include <iostream.h>

#include "global.h"
#include "dialogs.h"

extern DATEN *daten;

findDlg::findDlg( QWidget *parent=0, const char *name=0 ) : QWidget( parent, name )
{
	currentButton = 0;
	mailSearchCount = 0;

	QGroupBox *editBox = new QGroupBox( i18n("Zu suchender Text"), this );
	editBox->move( 5, 5 );
	editBox->resize( 220, 45 );
	
	edit = new QLineEdit( editBox );
	edit->move( 5, 15 );
	edit->resize( 210, 25 );

	buttonGroup = new QButtonGroup( this );
	buttonGroup->move( 5, 55 );
	buttonGroup->resize( 220, 73 );

	QObject::connect( buttonGroup, SIGNAL(clicked(int)), this, SLOT(slotCheckButtons(int)));

	QRadioButton *boxSearch = new QRadioButton( i18n("In der Box suchen"), buttonGroup );
	boxSearch->move( 5, 10 );
	boxSearch->resize( 200, 25 );
	boxSearch->setChecked( true );

	QRadioButton *mailSearch = new QRadioButton( i18n("In der Mail suchen"), buttonGroup );
	mailSearch->move( 5, 40 );
	mailSearch->resize( 200, 25 );

/*
	QRadioButton *archiveSearch = new QRadioButton( i18n("In empfangenen Headers suchen"), buttonGroup );
	archiveSearch->resize( 205, 25 );
	archiveSearch->move( 5, 70 );
*/

	ok = new QPushButton( i18n("suchen"), this );
	ok->move( 5, 135 );
	ok->resize( 105, 25 );

	QObject::connect( ok, SIGNAL(clicked()), this, SLOT(okPressed()));

	abort = new QPushButton( i18n("fertig"), this );
	abort->move( 118, 135 );
	abort->resize( 105, 25 );
	
	QObject::connect( abort, SIGNAL(clicked()), this, SLOT(abortPressed()));

	resize( 230, 165 );
	show();
}

findDlg::~findDlg()
{
}


void findDlg::okPressed()
{

	daten->search = edit->text();
	daten->search =	daten->search.lower();

	if ( currentButton == 0 )
	{
		QString tmp = daten->search;
		tmp.prepend( "c < \"" );
		tmp.append( "\"" );
		sendString( tmp );
	}

	else
	{
		if ( mailSearchCount == 0 )
			mailSearch( true );
		else
			mailSearch( false );
		
    mailSearchCount++;	//zaehlt wie oft in der mail gesucht wurde!
	}

}

void findDlg::closeEvent( QCloseEvent *ce )
{
 ce->ignore();
 abortPressed();
}

void findDlg::abortPressed()
{
	delete buttonGroup;
	delete edit;
	delete ok;
	delete abort;
	delete this;
}


void findDlg::slotCheckButtons( int id )
{
	currentButton = id;
}