/***************************************************************************
                          download.cpp  -  description
                             -------------------
    begin                : Thu Aug 31 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "download.h"
#include "global.h"
#include "crc.h"

#include <qdir.h>
#include <stdio.h>
#include <iostream.h>
#include <qmessagebox.h>
#include <kapp.h>
#include <string.h>

extern DATEN *daten;

extern bool debugMode;

siebenPlus::siebenPlus() : QObject () {

receive7Plus = false;
secondOne = false;
}


siebenPlus::~siebenPlus() {
}


void siebenPlus::parse_line_4_7plusHeader( QString line ) {

line.append("\n");

if ( receive7Plus ) { // der 7plus header wurde gefunden also werden die folgenden zeilen in die datei geschrieben

	storedFile.writeBlock( line, line.length() );

	downloadedBytes = downloadedBytes + 70;
	downBytes( downloadedBytes );
}


if ( line.find("go_7+.") == 1 ) {		// wenn der 7plus-header gefunden wird..

	downloadAborted = false;

	daten->downloadStarted = true; // es hat ein download begonnen!

	cout << "7plus zeile gefunden!\n";

	fileName = line.mid( 19, 12 );

	while ( fileName.find(" ") != -1 ) fileName.remove( fileName.find(" "), 1 );

	cout << "fileName: " << fileName << "\n";

	part = line.mid( line.find(" of ")-3, 10 );

	cout << "part: " << part << "\n";

  fileLength = hexStr2int( line.mid( (line.find("(7PLUS") - 4), 3 ) );

	cout << "fileLength: " << ( (fileLength * 70) + 210 ) << "\n";

	QString fileTmp = daten->downloadPath;
	fileTmp.append( "/" );
	fileTmp.append( fileName );
	fileTmp.append( ".tmp" );

	while ( fileTmp.find( "//" ) != -1 ) fileTmp.remove( fileTmp.find( "//" ), 1 ) ;

	storedFile.setName( fileTmp );

  if ( !storedFile.open( IO_WriteOnly ) ) {
      QMessageBox::information( 0, "PMC", i18n("Konnte die Datei nicht ffnen! :( \n ") );
  }
	else {

			emitStatus( 12 );  // 7plus empfang
			receive7Plus = true;
			storedFile.writeBlock( line, line.length() ); //erste zeile bereits ins file schreiben

			downloadedBytes = downloadedBytes +70;	

			if( !secondOne ) {
		  	sPlusDownload = new sPlusDownWin( 0, fileName, ((fileLength * 70) + 140), part );

		  	QObject::connect( this, SIGNAL(downBytes(long)), sPlusDownload,
													SLOT(downloadBytes(long)));

				secondOne = true;
			
/*
		    QObject::connect( this, SIGNAL(ourPart(QString, long)),
													sPlusDownload, SLOT(getPart(QString, long)));
*/

				QObject::connect( sPlusDownload, SIGNAL(downloadAborted()),
													this, SLOT ( slotDownloadAborted()) );

     		}
	}


}

if( line.find("stop_7+." ) == 1 ) {

	emitStatus( 1 );

	daten->downloadStarted = false; // download ist beendet (es koennen wieder texte in den editor gelassen werden)

	receive7Plus = false;
	storedFile.close();

	secondOne = false;
	downloadFinished();

	downloadedBytes = 0;

	if (!downloadAborted)
		delete sPlusDownload;													

	QString fileTmp = fileName;
	fileTmp.append( ".tmp" );

	QString fileTmp2 = line.mid( 11, 12 );

	if( fileTmp2.find( "/" ) != -1 )
		fileTmp2.resize( fileTmp2.find("/") + 1 );

 	QDir Dir( daten->downloadPath );
 	Dir.rename( fileTmp, fileTmp2 );

	cout << "old File: " << fileTmp << "\n";
	cout << "new File: " << fileTmp2 << "\n";
}

}


void siebenPlus::slotDownloadAborted() {
 downloadAborted = true;
 daten->downloadStarted = false; // download abgebrochen .. editor wieder zeilen lesen lassen!
}


int siebenPlus::hexStr2int( QString HexString ) {

char *hexString = qstrdup ( HexString );

int Erg[3];

int z;

for( z=0;z<3;z++ ) {

switch( hexString[z] )
{
 case 48: Erg[z] = 0;break;
 case 49: Erg[z] = 1;break;
 case 50: Erg[z] = 2;break;
 case 51: Erg[z] = 3;break;
 case 52: Erg[z] = 4;break;
 case 53: Erg[z] = 5;break;
 case 54: Erg[z] = 6;break;
 case 55: Erg[z] = 7;break;
 case 56: Erg[z] = 8;break;
 case 57: Erg[z] = 9;break;
 case 65: Erg[z] = 10;break;
 case 66: Erg[z] = 11;break;
 case 67: Erg[z] = 12;break;
 case 68: Erg[z] = 13;break;
 case 69: Erg[z] = 14;break;
 case 70: Erg[z] = 15;break;
 default: cout << "default" << "\n";
}
}

int fileLength7plus = (Erg[0] * 256) + (Erg[1] * 16) + Erg[2];

return( fileLength7plus );
}


/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////// autoBin //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////


autoBin::autoBin() : QObject() {

strTmp[0] = '\0';
}

autoBin::~autoBin() {

}

// diese Funktion zieht wieder einzelne Zeilen aus dem Datenpaket..
// Sie benutzt kein QString da ich die daten keiner verfaelschung aussetzen
// darf.. sobald der #bin#-header gefunden wird gibt die funktion checkLine
// ein true aus und von da an sollte alles in eine datei gespuelt werden.. ;-)
// der dataFrame dient nur fuer die Binaer-Uebertragung .. das zerteilen
// in zeilen wird ueber die Kopie von dataFrame (data) bewerkstelligt
void autoBin::rxData( char *dataFrame, int length ) {

	char data[1024];

  strncpy( data, dataFrame, length );

	int frameLength = length;
	char line[1024];
	int pos;


	while( length > 0 && !runBinTransfer ) {

		if ( findeN( '\r', data, length ) != -1 ) {

			if ( strTmp[0] != '\0' ) {

				strncat( strTmp, data, length );

				length = length + remindingLength;

				strncpy( data, strTmp, length );

				strTmp[0]='\0';
			}

			memcpy( line, data, ( findeN( '\r', data, length ) +1 ) );	

			pos = findeN('\r', line, length );

			line[ pos ] = '\0';	// string terminieren ...

			runBinTransfer = checkLine( line );

			length = length - (pos+1);


			if ( runBinTransfer ) {
//				 cout <<"chars"<< dataFrame[frameLength-length]<<"\n";
//				 cout <<"length" << length << " FrameLength " << frameLength << "\n";
				 memmove( &dataFrame[0], &dataFrame[ frameLength-length ], length );


			}
			memmove( &data[0], &data[ pos+1 ], length );


		}
		else {

			strncpy( strTmp, data, length );
			strTmp[length] = '\0';
			remindingLength = length;
			length = 0;

			}
			
	}




	if ( runBinTransfer && length > 0 ) {

		if ( receivedBytes == 0 ) {		// wenn die ersten daten empfangen werden muessen noch ein paar sachen erledigt werden(file oeffnen etc)

			fileName.prepend("/");
			fileName.prepend( daten->aDownloadPath );

			while ( fileName.find("//") != -1 )	fileName.remove( fileName.find("//"), 1 );// vor fehleingaben sichern..

			if ( debugMode ) cout << "ABIN - File stored to: " << fileName << "\n";

			storedFile.setName( fileName );

			if ( !storedFile.open( IO_WriteOnly ) )
				QMessageBox::information( 0, "PMC", i18n("Konnte die Datei NICHT ffnen! :(") );

			ourCRC = 0;

			emitStatus( 13 ); // sendet status (autbin-empfang) an die statuszeile...			

			downWin = new downloadWin( 0, fileNameWithoutPath, fileLength );

			downloadAborted=false;

			QObject::connect( downWin, SIGNAL( downloadAborted(bool)), this, SLOT( slotDownloadAborted(bool)) );
		}

		receivedBytes = receivedBytes + length;

		if ( receivedBytes > fileLength ) {		// es soll nicht mehr als notwendig ins file rein :)))

			int tmpint = receivedBytes - fileLength;
			length = length - tmpint;

			receivedBytes = fileLength;
		}

		ourCRC = calc_crcthp_str( dataFrame, length, ourCRC );		//CRC-Berechnung

		if ( !downloadAborted )
			downWin->downloadBytes( receivedBytes );

//		cout << "crc: " << ourCRC;

		storedFile.writeBlock( dataFrame, length );

//		cout << " | length: " << receivedBytes << "\n";

		if ( receivedBytes >= fileLength ) {

			daten->downloadStarted = false; // download beendet .. editor wieder zeilen lesen lassen!
			emitStatus( 1 ); // download ist durch...
			receivedBytes = 0;
			runBinTransfer = false;
			storedFile.close();
			if( ourCRC != fileCRC )
				QMessageBox::information( 0, "PMC", i18n("CRC - Fehler") );
		}	

	}

}



bool autoBin::checkLine( QString line ) {

bool returnValue=false;

QString tmp;

// cout << line << "\n";

if ( line.find( "#BIN#" ) == 0 && line.find("#|") != -1 && line.find("#$") != -1 ) {
// dieses IF zerpflueckt diese zeile -> #BIN#161027#|59065#$291B96F0#ZipStar03.zip
// in die einzelteile.. fileLength, fileCRC & fileName

	daten->downloadStarted = true; // es hat ein download begonnen!

	line.remove( 0, 5 );
	tmp = line.left( line.find("#|") );
	fileLength = tmp.toLong();
	line.remove( 0, line.find("#|") +2 );
	tmp = line.left( line.find("#$") );
	fileCRC = tmp.toUShort();
	line.remove( 0, line.find( "#$") +2 );
	line.remove( 0, line.find( "#" ) +1 );

	while( line.find( "\\" ) != -1 )	line.remove( 0, (line.find( "\\" ) +1) ); //damit der dos-pfad nicht mitgenommen wird!

	fileName = line;
	fileNameWithoutPath = fileName;
	returnValue = true; 	// wir haben die #bin#-Zeile gefunden..	

	if ( debugMode ) {
		cout << "tmp " << tmp << "\n";
		cout << "fileLength " << fileLength << "\n";
		cout << "fileCRC " << fileCRC << "\n";	
		cout << "fileName " << fileName << "\n";
		cout << "Found abin-Header!\n";
	}
}

return( returnValue );
}



void autoBin::slotDownloadAborted(bool state)
{
	downloadAborted = state;
	daten->downloadStarted = false; // download abgebrochen .. editor wieder zeilen lesen lassen!
}



int autoBin::finde(char zeichen, const char *str)
{
  int i,pos;

  i = 0;
  pos = -1;
  while ((str[i]!='\0') && (pos==-1)) {
    if (str[i]==zeichen) pos = i;
    i++;
  }

  return pos;
}


int autoBin::findeN(char zeichen, const char *str, int max )
{
  int i,pos;

  i = 0;
  pos = -1;
  while( (i < max) && (pos == -1) ) {
    if (str[i]==zeichen) pos = i;
		i++;
  }

  return pos;
}



/* Berechnet die CRC aus einem ganzen String */
unsigned short autoBin::calc_crcthp_str(const char *str, const int len, unsigned short crc)
{
  int i;

  i = 0;
  while (i < len)
  {
    crcthp(str[i],&crc);
    i++;
  }

  return(crc);
}
