/***************************************************************************
                          download.h  -  description
                             -------------------
    begin                : Thu Aug 31 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qobject.h>
#include <qstring.h>
#include <qfile.h>

#include "sPlusDownWin.h"
#include "downloadWin.h"

class siebenPlus : public QObject {

Q_OBJECT;

public:
	siebenPlus();
	~siebenPlus();

public slots:
	void parse_line_4_7plusHeader( QString );
	void slotDownloadAborted();
	
private:
	QString fileName;
	QString part;
	QFile storedFile;
	int fileLength;
	sPlusDownWin *sPlusDownload;
	bool receive7Plus, secondOne, downloadAborted;
	int hexStr2int( QString );
	long downloadedBytes;

signals:
	void downloadFinished();
	void downBytes( long );
	void emitStatus( int );
};

/////////////////////////////////////////////////////////////////////////////
///////////////////////////// autoBin ///////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

class autoBin : public QObject {

Q_OBJECT;

public:
	autoBin();
	~autoBin();

public slots:
	void rxData( char *, int );
	int finde( char, const char *);
	int findeN( char, const char *, int );
	bool checkLine( QString );
	unsigned short calc_crcthp_str(const char *, const int, unsigned short);
	void slotDownloadAborted( bool );

private:
	char strTmp[1024];
	long fileLength;
	long receivedBytes;
	int remindingLength;
	unsigned short fileCRC;
	unsigned short ourCRC;
	bool runBinTransfer;
	bool downloadAborted;
	downloadWin *downWin;
	QString fileName, fileNameWithoutPath;
	QFile storedFile;

signals:
	void emitStatus( int );
};