/***************************************************************************
                          editors.cpp  -  description
                             -------------------
    begin                : Fri Jun 30 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qkeycode.h>

#include "editors.h"
#include "global.h"
#include "adressbuch.h"

extern DATEN *daten;

extern KApplication *app;

extern bool debugMode;

outputEdit::outputEdit( QWidget *parent=0, const char *name=0 ) : QMultiLineEdit( parent, name ) {

if (debugMode == true ) cout << "outputEdit-Klasse\n";

setFont( daten->editorFont );

mailText = false;

show();
}

outputEdit::~outputEdit() {

}


void outputEdit::parseForMail( QString str ) {

if ( str.find( daten->mailReceived ) != -1 ) {		// gesendete Mail wurde empfangen? (gehoert eigentlich in mailWriteWidget...
	emitStatus( 1 );
	emitStatus( 7 );
}

if ( str.find( daten->erasedMail ) != -1 ) {		// Mail wurde geloescht? (gehoert eigentlich nicht unbeidingt hier rein)
	emitStatus( 1 );
	emitStatus( 9 );
}


/* Hier wird Talk fuer Baycom abgefragt! */
if ( str.find( "*" ) == 0 && ( str.find( "*: " ) >= 6 && str.find( "*: " ) < 10 ) && !mailText )
{
	if ( !daten->talkMonitor ) {
		talkWid = new talkWidget();
		daten->talkMonitor = true;
		QObject::connect( talkWid, SIGNAL( sendTalkString( QString )),
											this, SLOT( slotSendString( QString )));
	}

	if ( daten->talkMonitor )
		talkWid->rxTalkString( str );
}	

/* Hier wird Talk fuer DP abgefragt */
if ( ( str.find( "*** connect request of " ) == 0 || ( daten->talkMonitor && daten->boxTyp == "dp" ) ) && !mailText )
{
	if ( !daten->talkMonitor ) {
		talkWid = new talkWidget();
		daten->talkMonitor = true;

		QString temp = str;
		temp.remove( 0, temp.findRev( " " ) );

		temp.append( i18n (" moechte mit ihnen chatten!\n\nSolange Sie im chat sind koennen Sie keine Kommandos " ) );
		temp.append( i18n ("an die Box senden!\nErst wenn Sie das Chat-Fenster wieder geschlossen haben (X-Close) knnen\n" ) );
		temp.append( i18n ("Sie wieder Kommandos an die Box senden!") );

		QMessageBox::information( this, "PMC - Talk Request", temp );
		
		QObject::connect( talkWid, SIGNAL( sendTalkString( QString )),
											this, SLOT( slotSendString( QString )));
	}

	else
		talkWid->rxTalkString( str );
}	


if ( str.find( daten->mailBeginning ) != -1 && mailText == false ) {
	clear();
	setFont( daten->editorFont );
	emitStatus( 1 );
	mailText = true;
}

if ( str.find( daten->boxPrompt ) != -1 && mailText == true ) mailText = false;


if ( mailText == true && !daten->downloadStarted ) {

/*
   // wenn der string zu lang wird muss er gekuerzt werden..
	while( str.length() > daten->autoReturn ) {
		append( str.left( daten->autoReturn ) );
		str.remove( 0, daten->autoReturn );
	}

	if ( str.length() <= daten->autoReturn ) {
*/
			append( str );

//}

}

}


void outputEdit::slotSendString( QString str )
{
	sendString( str );
}


/* die Mail-Suchfunktion greift auf diese funktion zu!(findDlg) */
void outputEdit::searchEngine( bool first )
{
	setFocus();

	if ( first ) findLine=0;

	int maxLine = numLines();

	bool help = false;

	QString str;

	while( findLine<maxLine && !help )
	{
		str = textLine( findLine );
		str = str.lower();

		if( str.find( daten->search ) != -1 )
		{
			findCol = str.find( daten->search );

			setCursorPosition( findLine, findCol );

			unsigned int z;
		
			for( z=0; z<daten->search.length(); z++ )
				cursorRight( true );                    //wort markieren!

			help = true;
		}
   	
		findLine++;
	}


}

/////////////////////////////////////////////////////////////////////////////


inputEdit::inputEdit(KApplication *a=0, QWidget *parent=0, const char *name=0, const char *filename=0 )
	: KEdit(a, parent, name, filename )
{
	if (debugMode == true ) cout << "inputEdit-Klasse\n";

	setFont( daten->editorFont );

	setFillColumnMode( daten->autoReturn, true );

	show();
}
/*
void inputEdit::keyPressEvent( QKeyEvent *ke )
{
	QMultiLineEdit::keyPressEvent( ke );
	cout << "ok\n";

	getCursorPosition( &curPosY, &curPosX );

	if ( daten->autoReturn > 0 )
	{

   	if ( ke->state() != 16 && ke->state() != 8 && ke->key() != Key_Control && ke->key() != Key_Shift ) //erstmal versuchen!
		{
			setAutoUpdate( false );

			while ( curPosY <= numLines() -1 && ( lineLength( curPosY ) > daten->autoReturn ) )
			{						
				cout << "juhu\n";

				getCursorPosition( &sichPosY, &sichPosX );				
				while( lineLength( curPosY ) > daten->autoReturn )
					startNewLine();
	
				if ( sichPosX < daten->autoReturn )
					setCursorPosition( sichPosY, sichPosX );				

				curPosY++;
      }

			setAutoUpdate( true );		

		}
	}

}


void inputEdit::startNewLine()
{

	int newPosY, newPosX;

	QString line = textLine( curPosY );

	if ( line.find( " " ) != -1 )
	{
				getCursorPosition( &newPosY, &newPosX );

				if ( (numLines() -1) > curPosY )		//irgendwie muessen wir das alte return entfernen
				{
					insertAt (" ", curPosY+1, 0 );
					setCursorPosition( curPosY, lineLength( curPosY ) );
					del();
				}

				setCursorPosition( newPosY, newPosX );

				insertAt ("\n", curPosY, line.findRev( " " )+1 );

				getCursorPosition( &newPosY, &newPosX );

				setCursorPosition( curPosY, line.findRev( " " ) );
				del();

				setCursorPosition( newPosY, newPosX );

	}

	if ( curPosX < ( lineLength( curPosY ) -1 ) )
	{
			setCursorPosition( curPosY, curPosX );

	}
}
*/
/////////////////////////////////////////////////////////////////////////////


mailWriteWidget::mailWriteWidget( QWidget *parent, QString rcver, QString title, QString mailTxt, QString verteiler, bool isRubrik )
																	: KTMainWindow() {

resize( daten->writeEditX, daten->writeEditY );

if (debugMode == true ) cout << "mailWriteWidget-Klasse\n";

editFrame = new mailWriteFrame( this );

if( rcver != "0" && title !="0" && mailTxt != "0" && verteiler != "0" ) {

	if( isRubrik ) {
		rcver.append( "@" );
		if( verteiler != "?" )	rcver.append( verteiler );
		else	rcver.append( "DL" );
  }

	editFrame->empfaenger->setText( rcver );

	title.prepend("Re: " );
	editFrame->betreff->setText( title );

	QString tmp = "> ";

	if( mailTxt.right(1) != "\n") mailTxt.append( "\n" );

	while( !mailTxt.isEmpty() ) {
		tmp.append( mailTxt.left( mailTxt.find("\n")+1 ) );
		tmp.append("> ");
		mailTxt.remove( 0, mailTxt.find("\n") +1 );
	}

	editFrame->edit->setText( tmp );
}

createToolBar();

setView( editFrame );

show();

}

mailWriteWidget::~mailWriteWidget() {

}

void mailWriteWidget::createToolBar() {

toolBar()->insertButton( Icon( "send.xpm" ), 1, SIGNAL( clicked() ),
													this, SLOT( sendMail() ), true, i18n( "Nachricht absenden" ) );

toolBar()->insertSeparator();

toolBar()->insertButton( Icon( "filefloppy.xpm" ), 2, SIGNAL( clicked() ),
													this, SLOT( saveToFile() ), true, i18n( "Nachricht lokal speichern" ) );

toolBar()->insertButton( Icon( "fileprint.xpm" ), 3, SIGNAL( clicked() ),
													this, SLOT( printEditorText() ), true, i18n( "Nachricht drucken" ) );

toolBar()->insertSeparator();

toolBar()->insertButton( Icon( "editcut.xpm" ), 4, SIGNAL( clicked() ),
													editFrame->edit, SLOT( cut() ), true, i18n( "Auschneiden" ) );

toolBar()->insertButton( Icon( "editcopy.xpm" ), 5, SIGNAL( clicked() ),
													editFrame->edit, SLOT( copyText() ), true, i18n( "Kopieren" ) );

toolBar()->insertButton( Icon( "editpaste.xpm" ), 6, SIGNAL( clicked() ),
													editFrame->edit, SLOT( paste() ), true, i18n( "Einfgen" ) );

}

void mailWriteWidget::sendMail() {

QString sendCmd= "s ";

sendCmd.append( editFrame->empfaenger->text() );
sendCmd.append( " #" );

sendCmd.append( editFrame->LT->text() );
sendCmd.append( " " );
sendCmd.append( editFrame->betreff->text() );

sendCmd.append( "\n" );

sendCmd.append( editFrame->edit->text() );
sendCmd.append( "\n\n" );

sendCmd.append( daten->mailAbschlussTxt );

if( sendCmd.right( 1 ) != "\n" ) sendCmd.append( "\n" );

// vielleicht noch einen end-fix-text einfuegen ... mal schauen...

sendCmd.append( "NNNN\n" ); // eventuell einstellbar machen..

sendMailToNet( sendCmd );
emitStatus( 6 );
}


void mailWriteWidget::printEditorText() {

int z, siteCount, z2, z3;

z = 0;

QString editorText = editFrame->edit->text();

QString site;


QPrinter prt;
if ( prt.setup() ) {
	QPainter p;

	z = editorText.contains( "\n" );

	if ( z > 69 ) {

		siteCount = z / 69;

		for( z2=0; z2<siteCount; z2++ ) {

			site=NULL;
			
			for( z3=0; z3<69; z3++ ) {

				site.append( editorText.left( editorText.find("\n") +1) );
				editorText.remove( 0, editorText.find("\n") +1 );
			}	

			z = z -69;

			p.begin( &prt );
			p.setFont( QFont("courier", 10 ) );  //feste groesse damit der seitenwechsel passt (muss leider sein :( )
		  p.drawText( 10, 30, 100, 100, AlignLeft|AlignTop|DontClip, site );
			p.end();

//			prt.newPage();    	
			
	    if (debugMode == true ) cout << "site " << "\n";

		}				
	}			


	p.begin( &prt );
	p.setFont( QFont("courier", 10 ) );  //feste groesse damit der seitenwechsel passt (muss leider sein :( )
  p.drawText( 10, 30, 100, 100, AlignLeft|AlignTop|DontClip, editorText );
	p.end();


}
}



void mailWriteWidget::saveToFile() {

QString editorText = editFrame->edit->text();
QString saveFile = QFileDialog::getSaveFileName( QDir::homeDirPath() );

if ( saveFile != NULL ) {

	QFile file( saveFile );

	if( file.exists() ) {
		switch (
			QMessageBox::information( this, "PMC", i18n("Das File existiert bereits!\nberschreiben?"),i18n("Ja"),i18n("Nein"),0,1 )
			) {
				case 0:
					if ( file.open( IO_WriteOnly ) ) {
						file.writeBlock( editorText, editorText.length() );
				  }
				  else {
						QMessageBox::information( this, "PMC", i18n("PMC kann das File nicht anlegen :(") );	
					}
				  break;
				case 1: cout << "PMC: no File stored!\n";
			}
	}
	else {

		if ( file.open( IO_WriteOnly ) ) {
			file.writeBlock( editorText, editorText.length() );
	  }
	  else {
			QMessageBox::information( this, "PMC", i18n("PMC kann das File nicht anlegen :(") );	
		}	
	}

}
}



void mailWriteWidget::killMe() {

daten->writeEditX = width();
daten->writeEditY = height();

delete editFrame;
delete this;
}

void mailWriteWidget::closeEvent( QCloseEvent *CE ) {

CE->ignore();
killMe();

}


////////////////////////////////////////////////////////////////////////////

mailWriteFrame::mailWriteFrame(QWidget *parent=0, const char *name=0 ) : QWidget( parent, name ) {

if (debugMode == true ) cout << "mailWriteFrame-Klasse\n";

empfTxt = new QLabel( i18n( "Empfnger:" ), this );

empfTxt->move( 5, 5 );

empfTxt->resize( 70, 20 );

betreffTxt = new QLabel( i18n ( "Betreff:" ), this );

betreffTxt->move( 5, 27 );
betreffTxt->resize( 70, 20 );


empfaenger = new QLineEdit( this );

empfaenger->move( 70, 5 );
empfaenger->resize( 300 - empfTxt->width() - 50, 20 );

betreff = new QLineEdit( this );

betreff->move( 70, 27 );
betreff->resize( 300 - betreffTxt->width(), 20 );

adressBuchBut = new QPushButton( "...", this );

QObject::connect( adressBuchBut, SIGNAL( clicked()), this, SLOT(openAdressBook()));

adressBuchBut->resize( 50, 20 );

LTTxt = new QLabel( "#LT:", this );
LTTxt->resize( 30, 20 );

LT = new QSpinBox( 1, 999, 1, this );
LT->resize( 50, 20 );
LT->setValue( 30 );

edit = new inputEdit( app, this );

edit->move( 5, 50 );

show();

}



void mailWriteFrame::openAdressBook() {

QObject::connect( new adressBook, SIGNAL( selectedCall(QString) ), this, SLOT( setCallToEdit(QString)));
}



void mailWriteFrame::setCallToEdit( QString callsign ) {

empfaenger->clear();
empfaenger->setText( callsign );
}



void mailWriteFrame::resizeEvent( QResizeEvent *re ) {

empfaenger->resize( ( width() - empfTxt->width() - 60 ), 20 );
betreff->resize( ( width() - betreffTxt->width() - 95 ), 20 );
edit->resize( ( width() - 10 ), ( height() - 50 ) );

adressBuchBut->move( (width() - 55 ), 5 );
LTTxt->move( ( width() - 90 ), 27 );
LT->move( ( width() - 55 ), 27 );

}

mailWriteFrame::~mailWriteFrame() {
delete empfTxt;
delete betreffTxt;
delete betreff;
delete empfaenger;
delete adressBuchBut;
delete edit;
delete LTTxt;
delete LT;
}


///////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////// talkWidget ////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

talkWidget::talkWidget( QWidget *parent=0, const char *name=0 ) : QWidget( parent, name )
{

	setCaption( "PMC - Talk Monitor" );

	firstTime = true;

	outputEdit = new QMultiLineEdit( this );
	outputEdit->move( 5, 5 );

	outputEdit->setReadOnly( true );
	
	inputEdit = new QLineEdit( this );

	QObject::connect( inputEdit, SIGNAL( returnPressed() ), this, SLOT( slotReturnPressed() ) );

	resize( 400, 200 );
	show();
}


talkWidget::~talkWidget()
{
	delete outputEdit;
	delete inputEdit;
}


void talkWidget::rxTalkString( QString talkStr )
{
	if ( daten->boxTyp == "baycom" )		// wenn es eine DP-Box ist dann soll er nicht versuchen das call rauszuziehen
	{

		opposingCall = talkStr.mid( 1, (talkStr.find("*: ") -1) );

		if ( firstTime )
		{
			prependTalk();
			firstTime = false;
		}
	}

	outputEdit->append( talkStr );	
}


void talkWidget::resizeEvent( QResizeEvent *re )
{
	outputEdit->resize( width() - 10, height() - 37 );
	inputEdit->move( 5, height() - 30 );
	inputEdit->resize( width() - 10, 25 );
}


void talkWidget::slotReturnPressed()
{	
	sendTalkString(	inputEdit->text() );
	inputEdit->clear();
	prependTalk();
}


void talkWidget::prependTalk()
{
	if ( daten->boxTyp == "baycom" )
	{
		QString tmp = "talk ";
		tmp.append( opposingCall );
		tmp.append( " " );
		inputEdit->setText( tmp );
	}
}

void talkWidget::closeEvent( QCloseEvent *ce )
{
	ce->ignore();

 	if ( daten->boxTyp == "dp" )
	{

		sprintf( STRG_Z, "%c", 26 );
		sendTalkString( STRG_Z );
	}		
		
	daten->talkMonitor = false;
	delete this;
}