/***************************************************************************
                          editors.h  -  description
                             -------------------
    begin                : Fri Jun 30 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kapp.h>
#include <ktmainwindow.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpainter.h>
#include <qprinter.h>
#include <qprintdialog.h>
#include <qfile.h>
#include <qmessagebox.h>
#include <qspinbox.h>
#include <qmultilinedit.h>
#include <qlineedit.h>
#include <qfiledialog.h>
#include <qpushbutton.h>
#include <qpopupmenu.h>
#include <ktoolbar.h>
#include <kmenubar.h>
#include <kiconloader.h>
#include <keditcl.h>
#include <qstring.h>
#include <iostream.h>


///////////////////////////////////////////////////////////////////////
//////////////////////////// talkWidget ///////////////////////////////
///////////////////////////////////////////////////////////////////////


class talkWidget : public QWidget
{
	Q_OBJECT;

	public:
		talkWidget( QWidget *parent = 0, const char *name = 0 );
		~talkWidget();

		void prependTalk();

	public slots:
		void resizeEvent( QResizeEvent * );
		void rxTalkString( QString );
		void closeEvent( QCloseEvent * );

	private slots:
		void slotReturnPressed();

	private:
		QMultiLineEdit *outputEdit;
		QLineEdit *inputEdit;
		QString opposingCall;
		bool firstTime;
		char *STRG_Z; //nur das strg_z zeichen...

	signals:
		void sendTalkString( QString );

};


///////////////////////////////////////////////////////////////////////
/////////////////////////// outputEdit ////////////////////////////////
///////////////////////////////////////////////////////////////////////

class outputEdit : public QMultiLineEdit {

Q_OBJECT;

public:

	outputEdit( QWidget *parent=0, const char *name=0 );
	~outputEdit();


public slots:
	void parseForMail( QString );
	void slotSendString( QString );
	void searchEngine( bool );

private:
	bool mailText;
	talkWidget *talkWid;
	int findLine, findCol;

signals:
	void emitStatus( int );
	void sendString( QString );
};

////////////////////////////////////////////////////////////////////////
/////////////////////////// inputEdit //////////////////////////////////
////////////////////////////////////////////////////////////////////////

class inputEdit : public KEdit {

public:
	inputEdit( KApplication *a=0, QWidget *parent=0, const char *name= 0, const char *filename=0 );
	~inputEdit() {}
/*
protected:
	void keyPressEvent( QKeyEvent * );
	void startNewLine();


private:
	int curPosX, curPosY;
	int sichPosX, sichPosY;
*/
};


///////////////////////////////////////////////////////////////////////
// diese klasse ist noetig damit ich nachher in mailwritewidget einfach
// sagen kann setView(mailwriteframeobj) .. und die resizes ordentlich
// laufenn..
///////////////////////////////////////////////////////////////////////

class mailWriteFrame : public QWidget {

Q_OBJECT;

public:

	mailWriteFrame( QWidget *parent=0, const char *name=0 );
	~mailWriteFrame();

	QLineEdit *empfaenger, *betreff;
	QPushButton *adressBuchBut;
	inputEdit *edit;
	QSpinBox *LT;

public slots:
	void resizeEvent( QResizeEvent *re );
	void openAdressBook();
	void setCallToEdit( QString );

private:
	QLabel *empfTxt, *betreffTxt, *LTTxt;
};


///////////////////////////////////////////////////////////////////////
//////////////////////// mailWriteWidget //////////////////////////////
///////////////////////////////////////////////////////////////////////

class mailWriteWidget : public KTMainWindow {

Q_OBJECT;

public:
	mailWriteWidget( QWidget *parent, QString, QString, QString, QString, bool );
	~mailWriteWidget();

public slots:
	void createToolBar();
	void killMe();
	void closeEvent( QCloseEvent* );
	void sendMail();
	void printEditorText();

private slots:
	void saveToFile();

private:
	mailWriteFrame *editFrame;

signals:
	void sendMailToNet( QString );
	void emitStatus( int );
};


