/***************************************************************************
                          global.cpp  -  description
                             -------------------
    begin                : Thu Jun 29 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "global.h"
#include <kapp.h>
#include <qdir.h>

extern KApplication *app;

extern bool debugMode;

DATEN::DATEN() {

if (debugMode == true ) cout << "DATEN-Klasse\n";


workDir = ".pmc";

connectState = false;
downloadStarted = false;
talkMonitor = false;

aboutText = "PMC - Packet Mail Client v0.6.5\n\n by Philipp Lensing (DG2YLP)\n\n  maniac@squishers.de\n\n  dg2ylp@db0pke\n\nThis program is covered by GPL";
versionNumber = "PMC V 0.6.5";
checkList.setAutoDelete( true );
listList.setAutoDelete( true );

//check ob das Arbeits-Directory von PMC vorhanden ist..

QString dirTmp = QDir::homeDirPath();

if ( dirTmp.right( 1 ) != "/" ) {
	dirTmp.append("/");
}

dirTmp.append( workDir );

QDir pmcDir( dirTmp );

if( !pmcDir.exists() ) {
	pmcDir.mkdir( dirTmp );
	cout << "Create Directory: "<< dirTmp <<"\n";
}

workDir = dirTmp;

// daten aus konfig datei lesen..
hole_daten();

}

DATEN::~DATEN() {}


void DATEN::hole_daten() {

app->getConfig()->sync();
app->getConfig()->setGroup("ax25");

AX25myCall = app->getConfig()->readEntry("myCall", "nobody");

AX25myCall = AX25myCall.lower();
myCall = AX25myCall;

if( myCall.find( "-" ) != -1 ) myCall.resize( myCall.find( "-" )+1 ); //ssid muss wech :)

if (debugMode == true ) cout << "ax25myCall " << AX25myCall << " myCall " << myCall << "\n";

ax25Port = app->getConfig()->readEntry("AX25Port", "radio");
destCall = app->getConfig()->readEntry("destinationCall", "");
ax25Path = app->getConfig()->readEntry("destinationPath", "");

app->getConfig()->sync();
app->getConfig()->setGroup("window");

xMainCoord = app->getConfig()->readNumEntry("xMainWindow", 600);
yMainCoord = app->getConfig()->readNumEntry("yMainWindow", 400);
writeEditX = app->getConfig()->readNumEntry("writeEditorSize_X", 600);
writeEditY = app->getConfig()->readNumEntry("writeEditorSize_Y", 400);
editorFont = app->getConfig()->readFontEntry( "editorFont" );

app->getConfig()->sync();
app->getConfig()->setGroup("global");

firstStartUp = app->getConfig()->readBoolEntry("firstStartup", true);
autoReturn = app->getConfig()->readNumEntry( "autoReturn", 80 );
checkComand = app->getConfig()->readEntry("checkCommand", "c");
firstCmds = app->getConfig()->readEntry("firstCommands", "c");
password = app->getConfig()->readEntry("password", "");
passwordActive = app->getConfig()->readBoolEntry("passwordActive", false);
downloadPath = app->getConfig()->readEntry("7PlusDownloadPath", QDir::homeDirPath() );
aDownloadPath = app->getConfig()->readEntry("aBinDownloadPath", QDir::homeDirPath() );
sevenPlusActive = app->getConfig()->readBoolEntry("sevenPlusActivated", true );

QString tmp = "+++ ";
tmp.append( versionNumber );
tmp.append( " +++" );

mailAbschlussTxt = app->getConfig()->readEntry("mailEndingText", tmp );

while( mailAbschlussTxt.find(";;") != -1 ) {
	mailAbschlussTxt.replace( mailAbschlussTxt.find(";;"), 2, "\n" );
}

app->getConfig()->sync();
app->getConfig()->setGroup("parsing");

boxTyp = app->getConfig()->readEntry("boxTyp", "dp");
listHeader = app->getConfig()->readEntry("listHeader", "");
checkHeader = app->getConfig()->readEntry("checkHeader", "");
listGenreRow = app->getConfig()->readEntry("listGenreRow", "");
boxPrompt = app->getConfig()->readEntry("boxPrompt", "" );
mailBeginning = app->getConfig()->readEntry("mailBeginning", "");
mailReceived = app->getConfig()->readEntry("mailStoredInBox", "");
erasedMail = app->getConfig()->readEntry("confirmationForErasedMail", "");

app->getConfig()->sync();

}

void DATEN::speicher_daten() {

app->getConfig()->sync();
app->getConfig()->setGroup("ax25");

app->getConfig()->writeEntry("myCall", AX25myCall );
app->getConfig()->writeEntry("AX25Port", ax25Port );
app->getConfig()->writeEntry("destinationCall", destCall );
app->getConfig()->writeEntry("destinationPath", ax25Path );

app->getConfig()->sync();
app->getConfig()->setGroup("global");

firstStartUp = false;

app->getConfig()->writeEntry("firstStartUp", firstStartUp );
app->getConfig()->writeEntry("checkCommand", checkComand );
app->getConfig()->writeEntry("autoReturn", autoReturn );
app->getConfig()->writeEntry("firstCommands", firstCmds );
app->getConfig()->writeEntry("password", password );
app->getConfig()->writeEntry("passwordActive", passwordActive );
app->getConfig()->writeEntry("7PlusDownloadPath", downloadPath );
app->getConfig()->writeEntry("aBinDownloadPath", aDownloadPath );
app->getConfig()->writeEntry("sevenPlusActivated", sevenPlusActive );


while( mailAbschlussTxt.find("\n") != -1 ) {
	mailAbschlussTxt.replace( mailAbschlussTxt.find("\n"), 1, ";;" );
}

app->getConfig()->writeEntry("mailEndingText", mailAbschlussTxt );

app->getConfig()->sync();
app->getConfig()->setGroup("window");

app->getConfig()->writeEntry("xMainWindow", xMainCoord );
app->getConfig()->writeEntry("yMainWindow", yMainCoord );
app->getConfig()->writeEntry("writeEditorSize_X", writeEditX );
app->getConfig()->writeEntry("writeEditorSize_Y", writeEditY );
app->getConfig()->writeEntry("editorFont", editorFont );

app->getConfig()->sync();
app->getConfig()->setGroup("parsing");

app->getConfig()->writeEntry("boxTyp", boxTyp );
app->getConfig()->writeEntry("listHeader", listHeader );
app->getConfig()->writeEntry("checkHeader", checkHeader );
app->getConfig()->writeEntry("listGenreRow", listGenreRow );
app->getConfig()->writeEntry("boxPrompt", boxPrompt );
app->getConfig()->writeEntry("mailBeginning", mailBeginning );
app->getConfig()->writeEntry("mailStoredInBox", mailReceived );
app->getConfig()->writeEntry("confirmationForErasedMail", erasedMail );

app->getConfig()->sync();

}

