/***************************************************************************
                          lviews.cpp  -  description
                             -------------------
    begin                : Fri Jun 30 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "lviews.h"
#include "global.h"

#include <kiconloader.h>
#include <qmessagebox.h>

extern DATEN *daten;

extern bool debugMode;

rubrikView::rubrikView( QWidget * parent=0, const char * name=0 ) : QListView( parent, name ) {

if (debugMode == true ) cout << "rubrikView-Klasse\n";

checkHeaderFound = false;
listHeaderFound = false;
countEmptyRows = 0;

currentListRubrik = daten->myCall;

resize( 90, height() );

addColumn( i18n ("Rubrik"), width() );

privat = new QListViewItem( this, i18n ("Privat") );

rubriken = new QListViewItem( this, i18n("Rubriken"));
rubriken->setOpen( true );

show();
}

rubrikView::~rubrikView() {
}


void rubrikView::incomingLine( QString line ) {

// Die Rubrik welche mit List abgerufen wurde wird in currentListRubrik gespeichert!
if ( line.find( daten->listGenreRow ) != -1 ) {

	currentListRubrik = line;
	currentListRubrik.remove( 0, daten->listGenreRow.length() +1 );

	while( currentListRubrik.find(" ") != -1 )
		currentListRubrik.remove( currentListRubrik.find(" "), 1 );

	if ( currentListRubrik.find("\n") != -1 )
		currentListRubrik.remove( currentListRubrik.find("\n"), 1 );

	if( currentListRubrik.find("/") != -1 )			//baycom-boxen zeigen die rubriken anders an..
		currentListRubrik.remove( 0, currentListRubrik.find("/") + 1 );

	if( currentListRubrik.find(":") != -1 )		// auch ein : ist bei bcm mit drin..
		currentListRubrik.remove( currentListRubrik.find(":"), 1 );

	while( currentListRubrik.find("\"") != -1 ) 	// es kam vor das manche Boxen die Rubrik in "-Zeichen setzen..
		currentListRubrik.remove( currentListRubrik.find("\""), 1 );

	if( currentListRubrik.find("@") != -1 ) {
		currentListRubrik.resize( currentListRubrik.find("@") +1 );
		currentListRubrik = currentListRubrik.lower();
	}		

	if( currentListRubrik != daten->myCall ) 	// wenn das eigene rufzeichen kommt solls in privat und nich eine eigene rubrik werden..
		new QListViewItem( rubriken, currentListRubrik );

if (debugMode == true )	cout << "listGenreRow gefunden: " << currentListRubrik << "\n";
}

// wenn der Header einer List empfangen wird..
if ( line.find( daten->listHeader ) != -1 ) {
	listHeaderFound = true;
	emitStatus( 3 );
	
	if ( daten->boxTyp == "baycom" ) {
		countEmptyRows++; // baycom-boxen haben leider keine freizeile hinter dem listHeader;(
		if (debugMode == true ) cout << "Baycom: auotmatisch: countEmptyRows++\n";
	}
}

// wenn der Header eines Check's empfangen wurde..
if ( line.find( daten->checkHeader ) != -1 ) {
	checkHeaderFound = true;

	if (debugMode == true ) cout << "checkHeader gefunden!\n";

	emitStatus( 2 );	// checkliste wird empfangen..
}

// eine leere Zeile startet das Parsing und eine weitere beendet es!
if ( ( checkHeaderFound == true || listHeaderFound == true ) && ( line.isEmpty() || line.find( daten->boxPrompt ) != -1 ) )
	countEmptyRows++;


// Check-Eintraege in die CheckList aufnehmen!
if ( checkHeaderFound == true && countEmptyRows == 1 && !line.isEmpty() ) {

	if (debugMode == true ) cout << "Check-Row: " << line << "\n";
	daten->checkList.append( new QString( line ) );
	if (debugMode == true )	cout << "count " << daten->checkList.count() << "\n";
	insertCheckRubrik( line );
}


// List-Eintraege in die listList aufnehmen!
if ( listHeaderFound == true && countEmptyRows == 1 && !line.isEmpty() && line.find(daten->listHeader) == -1 ) {

	while( line.find( " " ) == 0 ) line.remove( 0, 1 ); //anfangsLeerzeichen loeschen!
	line.prepend( " " ); 																// eines soll jedoch bleiben..
	line.prepend( currentListRubrik );									// rubrikname einfach an erster stelle!
	daten->listList.append( new QString( line ) );			// in List-Liste setzen..

	if (debugMode == true ) cout << "List-Row: " << line << "\n";	
}

// wenn die 2. leere zeile empfangen wurde wird das parsing beendet!
if ( countEmptyRows >= 2 ) {
	countEmptyRows = 0;
	checkHeaderFound = false;
	listHeaderFound = false;
	emitStatus( 1 ); //standart-Status..
	if (debugMode == true ) cout << "Check- bzw. Listempfang beendet\n";
}


}

void rubrikView::insertCheckRubrik( QString chkStr ) {

chkStr.remove( 0, 15 );

QString rubrik = chkStr.left( 8 );

while( rubrik.find(".") != -1 ) rubrik.remove( rubrik.find("."), 1 );

if (debugMode == true ) cout << "setze Rubrik in ListView: " << rubrik << "\n";

if ( allRubriken.find( rubrik ) == -1 ) {
	allRubriken.append( rubrik );
	new QListViewItem( rubriken, rubrik );
}

}


void rubrikView::clear() {

daten->checkList.clear();		// man muss auch die Listen loeschen in denen die Mails gecacht wurden
daten->listList.clear(); 	// man muss auch die Listen loeschen in denen die Mails gecacht wurden

allRubriken = 0;					// rubriken-liste wieder loeschen .. damit der tree neu aufgebaut wird..

if (debugMode == true )
	cout << "Loesche Interne-Listen: " << daten->checkList.count() << " " << daten->listList.count() << "\n";

QListView::clear();

currentListRubrik = daten->myCall;

privat = new QListViewItem( this, i18n ("Privat") );

rubriken = new QListViewItem( this, i18n("Rubriken"));
rubriken->setOpen( true );

checkHeaderFound = false;
listHeaderFound = false;
countEmptyRows = 0;

currentListRubrik = daten->myCall;

}


void rubrikView::resizeEvent( QResizeEvent *re ) {

QListView::resizeEvent( re );

setColumnWidth( 0, width() );
}



////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////// mailView ///////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////




mailView::mailView( QWidget * parent=0, const char * name=0 ) : QListView( parent, name ) {

if (debugMode == true ) cout << "mailView-Klasse\n";

setAllColumnsShowFocus( true );

history.setAutoDelete( true );

resize( width(), 150 );

addColumn( i18n ("F"), 0 );
addColumn( i18n ("Absender"), 1 );
addColumn( i18n ("Betreff"), 2 );
addColumn( i18n ("Datum"), 3 );
addColumn( i18n ("Gre"), 4 );
addColumn( i18n ("Verteiler"), 5);
addColumn( i18n ("Mail-Nr."), 6 );

setColumnWidth( 0, 20 );
setColumnWidth( 1, 100 );
setColumnWidth( 2, 250 );
setColumnWidth( 3, 60 );
setColumnWidth( 4, 50 );
setColumnWidth( 5, 60 );
setColumnWidth( 6, 60 );

setColumnAlignment( 4, AlignRight );  // diese werte sollten rechtsbuendig sein..
setColumnAlignment( 5, AlignRight );
setColumnAlignment( 6, AlignRight );

setMultiSelection( true );

context = new QPopupMenu();
context->insertItem( i18n("markierte auslesen (7PLUS u. BIN)"), this, SLOT( readMarked() ) );

QObject::connect( this, SIGNAL( doubleClicked( QListViewItem * )),
									this, SLOT( sendReadCmd( QListViewItem * ) ));

QObject::connect( this, SIGNAL( rightButtonClicked(QListViewItem *, const QPoint &, int )),
									this, SLOT( openContext(QListViewItem *, const QPoint &, int )) );

show();
}

mailView::~mailView() {

}


void mailView::openContext( QListViewItem *Item, const QPoint &p, int smile ) {

context->exec( p );
}


void mailView::readMarked() {

QListViewItem *item = firstChild();

rubrik_mailNr r_mN;

QString sendtmp;

do {

	if ( item->isSelected() ) {

		if ( sendtmp.isEmpty() ) {		//bei dem ersten read muss die rubrik angegeben werden..						
			sendtmp = "r ";
			sendtmp.append( currentRubrik );
			sendtmp.append( " " );
			sendtmp.append( item->text( 6 ) );
		}
		else {
			sendtmp.append( ";r " );
			sendtmp.append( item->text( 6 ) );
		}

	// dies muss gemacht werden damit der status der Mail geaendert und gepeichert wird.. ->
	r_mN.rubrik = currentRubrik;
	r_mN.mailNr = item->text( 6 );
	r_mN.state = 1;

	history.append( new rubrik_mailNr = r_mN );

	item->setPixmap( 0, Icon( "kmmsgold.xpm" ) );
	// bis hier .......
	}

} while ( (item = item->itemBelow()) != 0 );

if ( !sendtmp.isEmpty() ) {

	sendtmp.append( "\n" );

	if (debugMode == true ) cout << sendtmp;

	emitStatus( 5 );		// status in der statusbar neu setzen..
	sendString( sendtmp ); 		// kommandos senden..

}
else {
	QMessageBox::information( this, "PMC", i18n("Es wurden keine Mails markiert!") );
}


}




void mailView::checkMailsForRubrik( QListViewItem *rubrik ) {

clear();

currentRubrik = rubrik->text( 0 );

if (debugMode == true ) cout << "Rubrik angeklickt: " << currentRubrik << "\n";

if ( currentRubrik == i18n ("Privat") ) {
	currentRubrik = daten->myCall;
	if (debugMode == true ) cout << "Rubrik ist Privat.. currentRubrik: " << currentRubrik <<"\n";
}

QString *tmp = daten->checkList.first();

//cout << *tmp << " count " << daten->checkList.count() <<"\n";

// Hier werden die Check-Mails durchsucht ->

while ( (uint) daten->checkList.at() <= daten->checkList.count() ) {

	tmp = daten->checkList.current();

	if( tmp->find( rubrik->text( 0 ) ) > 0 && tmp->find(rubrik->text( 0 )  ) < 30 ) {		
		 prepareCheckForList( tmp );
  }
	daten->checkList.next();
}

// und hier die List-Mails ->

tmp = daten->listList.first();

while ( (uint) daten->listList.at() <= daten->listList.count() ) {

	tmp = daten->listList.current();

	if( tmp->find( currentRubrik ) == 0 ) {		
		prepareListForList( tmp );
  }
	daten->listList.next();
}


}


void mailView::prepareCheckForList( QString *chk ) {

QString chkStr = *chk;

if (debugMode == true ) cout << "pCFL " << chkStr << "\n";


QString status;
QString absender, betreff, datum, mailNr, verteiler, groesse, rubrik;



QString listStr, tmpStr;

chkStr.remove( 0, 6 );

listStr = chkStr.left( chkStr.find( " " ) +1 );


absender = chkStr.left( chkStr.find( " " ) ); //absender der Mail



chkStr.remove( 0, chkStr.find( ">" ) +2 );

// hier muss nachher die rubriken funktion von dieser Klasse eingesetzt werden..

listStr.append( chkStr.left( chkStr.find( "." ) ) );	//rubrik in liststr
listStr.append( " " );

rubrik = chkStr.left( chkStr.find( "." ) );

if( rubrik.length() > 8 ) rubrik.resize( 9 );

tmpStr = chkStr.left( chkStr.find( " " )+1 );

if ( tmpStr.find( "." ) != -1 ) {

	tmpStr.remove ( 0, tmpStr.find(".") );

	while( tmpStr.find(".") != -1 ) tmpStr.remove( tmpStr.find("."), 1 );
}
else {
	tmpStr.remove( 0, 8 );   //manchmal kommt es vor das die Mailnr so gross ist das zwischen rubrik und mailnr keine punkte(.) mehr sind..
}

listStr.append( tmpStr );


mailNr = tmpStr;				//mailNr in mailNr.. ;)

if ( mailNr.find( " " ) != -1 ) mailNr.remove( mailNr.find(" "), 1 );

chkStr.remove( 0, chkStr.find( " " )+1 );

listStr.append( chkStr.left( chkStr.find(" ")+1 ) );  // datum


datum = chkStr.left( chkStr.find(" ") ); // datum in datum..


chkStr.remove( 0, chkStr.find(" ") +1);

listStr.append( chkStr.left( chkStr.find(" ")+1 ) );


verteiler = chkStr.left( chkStr.find(" ") );


chkStr.remove( 0, chkStr.find(" ") +1);

while( chkStr.find(" ") == 0 ) chkStr.remove( 0, 1 );	//die vorhergehenden leerzeichen loeschen!

listStr.append( chkStr.left( chkStr.find(" ")+1 ) );


groesse = chkStr.left( chkStr.find(" ") );


chkStr.remove( 0, chkStr.find(" ") +1);

while( chkStr.find(" ") == 0 ) chkStr.remove( 0, 1 );	//die vorhergehenden leerzeichen loeschen!

chkStr.remove( 0, chkStr.find(" ") +1);

listStr.append( chkStr );


betreff = chkStr;

if ( currentRubrik == rubrik ) {		// es hat probleme mit der auflistung gegeben (all wurde zb. in alle eingeordnet)
	QListViewItem *mailItem = new QListViewItem( this, status, absender, betreff, datum, groesse, verteiler, mailNr );

if (debugMode == true ) cout <<status<<" "<<absender<<" "<<betreff<<" "<<datum<<" "<<groesse<<" "<<verteiler<<" "<<mailNr<<"\n";

//in history nachschauen ob die Mail schon gelesen wurde..


	rubrik_mailNr *tmp2 = history.first();


	mailItem->setPixmap( 0, Icon( "kmmsgnew.xpm" ) );


	while ( (uint) history.at() <= history.count() ) {

		tmp2 = history.current();

		if ( rubrik == tmp2->rubrik && mailNr == tmp2->mailNr ) {

			if ( tmp2->state == 1 ) { mailItem->setPixmap( 0, Icon( "kmmsgold.xpm" ) ); }
			if ( tmp2->state == 3 ) { mailItem->setPixmap( 0, Icon( "kmmsgtrash.xpm" ) ); }
			//hier muessen noch mehr bedingungen und pixmaps rein..
	  }

		history.next();
	}

}
}



void mailView::prepareListForList( QString *Str ) {

QString lstStr = *Str;

if (debugMode == true ) cout << "pLFL " << lstStr << "\n";

QString status;		//temporaer!

QString absender, betreff, datum, mailNr, verteiler, groesse, rubrik;

rubrik = lstStr.left( lstStr.find( " " ) );

lstStr.remove( 0, lstStr.find( " " ) + 1 );


mailNr = lstStr.left( lstStr.find( " " ) );


lstStr.remove( 0, lstStr.find( " " ) + 1 );


absender = lstStr.left( lstStr.find( " " ) );


lstStr.remove( 0, lstStr.find( " " ) + 1 );

while( lstStr.find(" ") == 0 ) lstStr.remove( 0, 1 );


datum = lstStr.left( lstStr.find( " " ) );


lstStr.remove( 0, lstStr.find( " " ) + 1 );

// die uhrZeit auch mit einnehmen
datum.append( " " );
datum.append( lstStr.left( lstStr.find( " " ) ) );

lstStr.remove( 0, lstStr.find( " " ) + 1 );

while( lstStr.find(" ") == 0 ) lstStr.remove( 0, 1 );


groesse = lstStr.left( lstStr.find( " " ) );


lstStr.remove( 0, lstStr.find( " " ) + 1 );

while( lstStr.find(" ") == 0 ) lstStr.remove( 0, 1 );

betreff = lstStr;

verteiler = "?";

if ( currentRubrik == rubrik )	{	// es hat probleme mit der auflistung gegeben (all wurde zb. in alle eingeordnet)
	QListViewItem *mailItem = new QListViewItem( this, status, absender, betreff, datum, groesse, verteiler, mailNr );

if (debugMode == true ) cout <<status<<" "<<absender<<" "<<betreff<<" "<<datum<<" "<<groesse<<" "<<verteiler<<" "<<mailNr<<"\n";

	// in history nachsehen ob mail schonmal gelesen..


	rubrik_mailNr *tmp2 = history.first();


	mailItem->setPixmap( 0, Icon( "kmmsgnew.xpm" ) );


	while ( (uint) history.at() <= history.count() ) {

		tmp2 = history.current();

		if ( rubrik == tmp2->rubrik && mailNr == tmp2->mailNr ) {

			if ( tmp2->state == 1 ) { mailItem->setPixmap( 0, Icon( "kmmsgold.xpm" ) ); }
			if ( tmp2->state == 3 ) { mailItem->setPixmap( 0, Icon( "kmmsgtrash.xpm" ) ); }
		//hier muessen noch mehr bedingungen und pixmaps rein..
	  }

		history.next();
	}

}
}

// neue statusIcons setzen...
void mailView::setMailStatus( int status ) {

if(  currentRubrik == daten->myCall && status == 3 ) {
	lastDoubleClicked->setPixmap( 0, Icon( "kmmsgtrash.xpm" ) );
}


rubrik_mailNr *tmp2 = history.first();

while ( (uint) history.at() <= history.count() ) {

	tmp2 = history.current();

	if ( tmp2->rubrik == currentMailRubrik && tmp2->mailNr == currentMailNr ) {
		tmp2->state = status;		// neuen status fuer mail setzen..	
  }

	history.next();
}


}


void mailView::sendReadCmd( QListViewItem *curItem ) {

currentAbsender = curItem->text( 1 );
currentTitle = curItem->text( 2 );
currentVerteiler = curItem->text( 5 );
currentMailNr = curItem->text( 6 );

lastDoubleClicked = curItem;
currentMailRubrik = currentRubrik;

curItem->setPixmap( 0, Icon( "kmmsgold.xpm" ) );

QString sendRead = "r ";

sendRead.append( currentRubrik );
sendRead.append( " " );
sendRead.append( curItem->text( 6 ) );
sendRead.append( "\n" );

emitStatus( 5 );

sendString( sendRead );

if (debugMode == true ) cout << "Sende Read: " << sendRead << "\n";

rubrik_mailNr r_mN;

sendRead.remove( 0, 2 );

r_mN.rubrik = sendRead.left( sendRead.find( " " ) );

sendRead.remove( 0, sendRead.find(" ") +1 );

if ( sendRead.find("\n") != -1 ) sendRead.remove( sendRead.find("\n"), 1 );

r_mN.mailNr = sendRead;

r_mN.state = 1;				//nachrichtstatus "gelesen" sonst nichts ;)

history.append( new rubrik_mailNr = r_mN );

/*rubrik_mailNr *hist =*/ history.first();

if ( currentRubrik == daten->myCall ) setEnableToolIcon( 9, true );		//falls es eine private nachricht ist kann man sie auch loeschen..
else	setEnableToolIcon( 9, false );

}


