/***************************************************************************
                          lviews.h  -  description
                             -------------------
    begin                : Fri Jun 30 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qlistview.h>
#include <qlist.h>
#include <iostream.h>
#include <qpopupmenu.h>
#include <kapp.h>


struct rubrik_mailNr {

	QString rubrik;
	QString mailNr;
	int state;

};


class rubrikView : public QListView {

Q_OBJECT;

public:
	rubrikView( QWidget * parent=0, const char * name=0 );
	~rubrikView();

public slots:
	void resizeEvent( QResizeEvent * );
	void incomingLine( QString );
	void insertCheckRubrik( QString );
	void clear();

private:
	QListViewItem *privat, *rubriken;
	bool checkHeaderFound, listHeaderFound;
	int countEmptyRows;
	QString allRubriken;
	QString currentListRubrik;

signals:
	void emitStatus( int );
};

////////////////////////////////////////////////////////////////////

class mailView : public QListView {

Q_OBJECT;

public:
	mailView( QWidget * parent=0, const char * name=0 );
	~mailView();
  void prepareCheckForList( QString* );
	void prepareListForList( QString* );
	QString currentRubrik, currentAbsender, currentTitle, currentVerteiler, currentMailNr;
	QString currentMailRubrik; // die rubrik der letzt _DOPPELT_GECLICKETEN mail..

public slots:
	void checkMailsForRubrik( QListViewItem * );
	void sendReadCmd( QListViewItem *);
	void setMailStatus( int );
	void openContext(QListViewItem *, const QPoint &, int );
	void readMarked();

private:
	QList<rubrik_mailNr> history;
	QListViewItem *lastDoubleClicked;
	QPopupMenu *context;

signals:
	void sendString( QString );
	void emitStatus( int );
	void setEnableToolIcon( int, bool );
};

