/***************************************************************************
                          network.cpp  -  description
                             -------------------
    begin                : Thu Jun 29 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "network.h"
#include "global.h"

extern DATEN *daten;

extern bool debugMode;

AX25::AX25() : QObject() {

if (debugMode == true ) cout << "AX25-Klasse\n";

old_status = 0;
firstRX = false;

}

AX25::~AX25() {
close(fd);
}

void AX25::sendFirstCmds() {


if ( daten->boxTyp == "baycom" ) { 					// baycom-Boxen haben leider nicht das standart format beim login, wenn sie das Maildir
	QString reqPrivMailDir="l ";							// des users anzeigen .. deshalb muss man nochmal seperat das dir aufrufen, damit auch PMC
	reqPrivMailDir.append( daten->myCall );		// was damit anfangen kann...
	reqPrivMailDir.append( "\n" );
	writeDat( reqPrivMailDir );
}


QString tmp = daten->firstCmds;

while( tmp.find(";") != -1 )
	tmp.replace( tmp.find(";"), 1, "\n" );

if( tmp.right( 1 ) != "\n" )
	tmp.append("\n");

writeDat( tmp );						//temporaer!

}

void AX25::readDat( int fd ) {

if ( firstRX == false && daten->passwordActive == false ) sendFirstCmds();

int z, loc;
char data[1024], data2[1024];
int strLength;
QString rxRaw, str;

strLength = read(fd, data, sizeof( data ) );

data2 = data;

if ( strLength <= 0 ) {

	connectionLost();
}
else {

	for( z=0;z<=strLength;z++ ) {
		if (data[z] == 13) {data[z] = '\n';}
  }

	RXRawData( data2, strLength );  // Paket empfangen .. nicht aufgeteilt in Zeilen!!

	data[strLength] = '\0';

	rxRaw = data;

  while ( !rxRaw.isEmpty() )
  {
    if ( (loc = rxRaw.find('\n')) != -1 )
    {
      str = rxRaw;
      str.resize( loc+1 );
      if (strtmp != NULL ) {str.insert(0, strtmp); strtmp = NULL; }
      rxRaw.remove(0, loc+1);
      RXLineData( str ); // uebergebe der parsing-funktion
    }
    else
    {
      strtmp = rxRaw;
      rxRaw.resize(0);
    }
  }
	
}

firstRX = true;
}

void AX25::writeDat( QString tx ) {

if( tx.find("\n") == -1 ) tx.append("\n");

while( tx.find("\n") != -1 ) {

tx.replace( tx.find("\n"), 1, "\r" );

}

write( fd, tx, tx.length() );

}



void AX25::writeToBuffer( QString tx ) {

if (debugMode == true ) cout << "writeToBuffer\n";

send_buffer = tx;

while( send_buffer.find("\n") != -1 ) {
	send_buffer.replace( send_buffer.find("\n"), 1, "\r" );
}

count = 1024;

write_notify->setEnabled( true );

}



void AX25::writeBufferToNet(int) {

if (debugMode == true ) cout << "writebuffertonet\n";

QString tmp = send_buffer.left( count );

count =	write( fd, tmp, tmp.length() );

if ( count >= 0 ) {

	send_buffer.remove( 0, count ); 	// den buffer verkleinern

if (debugMode == true ) cout << "countwbtn " << count << "\n";

	if ( send_buffer.isEmpty() ) {
		write_notify->setEnabled( false );
if (debugMode == true ) cout << "disable socket\n";
	} //notify auschalten..
}

}



int AX25::createSocket( const char* mycall, const char* port, const char* path, const char* destcall,
												 bool multiconnect=false ) {
char tmp[500];


if (multiconnect == false ) {

	if (ax25_config_load_ports() == 0)
	{
   	printf("Error: No AX.25 port data available\n\n");
      exit(1);
	}


	if (ax25_config_get_addr( (char*) port) == NULL)
	{
      printf("Error: Invalid port setting for port %s.\n\n", port);
      exit(1);
	}

}

	paclen = ax25_config_get_paclen( (char*) port);


	if ( path == NULL )
		strcpy( tmp, destcall );
	else
		if ( path[0] == '\0' )
			strcpy(tmp, destcall);
		else
			sprintf(tmp,"%s %s", destcall, path);


#ifdef HAVE_NETAX25_AXLIB_H
	addrlen_d = ax25_aton(tmp,&ax25_d);
#else
	addrlen_d = convert_call(tmp,&ax25_d);
#endif
	if (addrlen_d == -1)
	{
		printf("Error: Cannot convert destinationcall - wrong format?\n\n");
      exit(1);
	}


	fd = socket( AF_AX25,SOCK_SEQPACKET, 0 );

   if (fd < 0)
   {
		printf("Error: Cannot add socket.\n\n");
      exit(1);
	}

	ax25.fsa_ax25.sax25_family = AF_AX25;
	ax25.fsa_ax25.sax25_ndigis = 1;

#ifdef HAVE_NETAX25_AXLIB_H
	ax25_aton_entry( mycall, ax25.fsa_ax25.sax25_call.ax25_call );
	ax25_aton_entry(ax25_config_get_addr( (char*) port ), ax25.fsa_digipeater[0].ax25_call);


#else
convert_call_entry(config->ax25mycall, ax25.fsa_ax25.sax25_call.ax25_call);
convert_call_entry(ax25_config_get_addr(config->ax25port), ax25.fsa_digipeater[0].ax25_call);

#endif
	addrlen = sizeof(struct full_sockaddr_ax25);

 //       printf ("fd = %i ", fd);

	if (bind(fd, (struct sockaddr *)&ax25, addrlen) == -1)
	{
   	printf("Error: Cannot bind socket.\n%s\n\n", strerror(errno));
		::close(fd);
    exit(1);
	}


	i = TRUE;
  ioctl(fd, FIONBIO, &i);

	write_notify = new QSocketNotifier( fd, QSocketNotifier::Write );
	write_notify->setEnabled( false );
	QObject::connect( write_notify, SIGNAL(activated(int)), this, SLOT(writeBufferToNet(int)));

	return( fd );
}


bool AX25::createConnect() {

bool alright = true;

int ok = ::connect(fd, (struct sockaddr *)&ax25_d, addrlen_d);

if ( ok != -1 )
{
	cout << "Error at connect!\n";
  alright = false;
}

timer = new QTimer( this );
QObject::connect(timer, SIGNAL(timeout()), this, SLOT(axState()));
timer->start(200, true);


return ( alright );

}

void AX25::axState() {
   int axstate;
   int tries,/*unack,*/squeue;
   ax25_info_struct axinfo;
   int err;
   bool restarttimer=true;


   if ((err = ioctl(fd, SIOCAX25GETINFO, &axinfo)) != -1)
   {
      tries = axinfo.n2count;

      squeue = axinfo.snd_q / 256;
      if ((squeue == 0) && (axinfo.snd_q > 0)) squeue = 1;

      switch (axinfo.state)
      {
         case 0:
           restarttimer = false;    // *kein* break!
         case 1:
           axstate = axinfo.state;
           break;
         case 2:
           axstate = 3;
           break;
         case 3:
           axstate = 4;
           break;
         case 4:
           axstate = 6;
           break;
         default:
           axstate = 0;
           break;
       }


// connect vorhanden!	
   if (((old_status == 1) && (axstate == 4)) ||
       ((old_status == 0) && (axstate == 4))) {

			if ( daten->connectState == false ) {
				daten->connectState = true;
				confirmConnect();
      }
	 }

// connect verloren!
   if ((old_status >= 1) && (axstate == 0)) {

		  daten->connectState = false;
    	connectionLost();
			cout << "disconnect!\n";
	 }

   if (restarttimer)

      timer->start(200, true);
}

}												