/***************************************************************************
                          network.h  -  description
                             -------------------
    begin                : Thu Jun 29 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qobject.h>
#include <qstring.h>
#include <iostream.h>
#include <unistd.h>

#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <sys/types.h>
#include <qsocketnotifier.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <string.h>
#include <time.h>
#include <qtimer.h>

#include "../config.h"

#ifdef HAVE_BROKEN_AX25_H
#include "local_ax25.h"
#include <netrose/rose.h>
#elif HAVE_NETAX25_AX25_H
#include <netax25/ax25.h>
#include <netrose/rose.h>
#else
#include <linux/ax25.h>
#include <linux/rose.h>
#endif

#ifdef HAVE_NETAX25_AXLIB_H
   #include <netax25/axconfig.h>
   #include <netax25/axlib.h>
#elif HAVE_AX25_AXUTILS_H
   #include <ax25/axconfig.h>
   #include <ax25/axutils.h>
#else
   #include <axconfig.h>
   #include <axutils.h>
#endif

class AX25 : public QObject {

Q_OBJECT

public:
 AX25();
 ~AX25();
 int createSocket( const char*, const char*, const char*, const char*, bool );
 bool createConnect();


public slots:
 void readDat( int );
 void writeDat( QString );
 void writeToBuffer( QString );
 void writeBufferToNet( int );
 void axState();
 void sendFirstCmds();


private:
 int fd;
 int paclen;
 struct full_sockaddr_ax25 ax25;
 int addrlen;
 struct full_sockaddr_ax25 ax25_d;
 int addrlen_d, i;
 QString strtmp;
 QTimer *timer;
 QString send_buffer;
 int old_status;
 int count;
 bool firstRX;
 QSocketNotifier *write_notify;

signals:
 void RXRawData( char *, int );
 void RXLineData( QString );
 void connectionLost();
 void confirmConnect();

};


