/***************************************************************************
                          pmc.cpp  -  description
                             -------------------
    begin                : Thu Jun 29 15:30:04 CEST 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "pmc.h"
#include "global.h"
#include "adressbuch.h"

#include "configdlg.h"

#include <qkeycode.h>

extern KApplication *app;

DATEN *daten;

extern bool debugMode;


PMC::PMC() : KTMainWindow() {

setCaption("PMC - Packet Mail Client" );

if (debugMode == true ) cout << "PMC-Klasse\n";

daten = new DATEN();

resize( daten->xMainCoord, daten->yMainCoord );

secondConnect=false;

split2 = new QSplitter( QSplitter::Horizontal, this );

rubrikListView = new rubrikView( split2 );

split1 = new QSplitter( QSplitter::Vertical, split2 );

split1->resize( daten->xMainCoord - 90, split1->height() );

mailListView = new mailView( split1 );

edit = new outputEdit( split1 );

edit->resize( daten->xMainCoord - 90, height() - 150 );

createMenuBar();			  // Menu-Zeile
createToolBar();				// Button-Zeile
createStatusBar();			// Status-Zeile

setView( split2 );

passW = new password();

sPlus = new siebenPlus();

aBin = new autoBin();

// ne menge connects fuer die kommunikation unter den klassen..

QObject::connect( rubrikListView, SIGNAL( selectionChanged( QListViewItem* ) ),
									mailListView, SLOT( checkMailsForRubrik( QListViewItem* ) ) );

QObject::connect( rubrikListView, SIGNAL( emitStatus( int )), this, SLOT(changeStatus(int)));

QObject::connect( edit, SIGNAL( emitStatus( int )), this, SLOT( changeStatus( int )));

QObject::connect( mailListView, SIGNAL( emitStatus( int )), this, SLOT(changeStatus(int)));

QObject::connect( sPlus, SIGNAL( emitStatus( int )), this, SLOT( changeStatus(int )));

QObject::connect( aBin, SIGNAL( emitStatus( int )), this, SLOT( changeStatus(int )));

QObject::connect( mailListView, SIGNAL( setEnableToolIcon( int, bool )),
									this, SLOT( enableToolIcon(int, bool ) ) );

if( daten->firstStartUp == true ) openSetup();

}

PMC::~PMC() {

}

void PMC::createMenuBar() {

datei = new QPopupMenu();
bearbeiten = new QPopupMenu();
verbindung = new QPopupMenu();

QPopupMenu *hilfe = app->getHelpMenu ( TRUE, daten->aboutText );

datei->insertItem( i18n("&Einstellungen"), this, SLOT(openSetup()), CTRL + Key_S );
datei->insertItem( i18n("&Adrebuch"), this, SLOT(openAdressBook()), CTRL + Key_A );
datei->insertSeparator();
datei->insertItem( i18n("&Quit"), this, SLOT( killMe()), CTRL + Key_Q );

bearbeiten->insertItem( i18n("&Kopieren"), edit, SLOT( copyText() ) );
bearbeiten->insertItem( i18n("&Einfgen"), edit, SLOT( paste() ) );
bearbeiten->insertItem( i18n("&Lschen"), edit, SLOT( cut() ) );
bearbeiten->insertSeparator();
bearbeiten->insertItem( i18n("&Suchen"), this, SLOT( openSearch() ), CTRL + Key_F );

verbindung->insertItem( i18n("&Connect"), this, SLOT( tryConnect()), CTRL + Key_C );

menuBar();
menuBar()->insertItem( i18n("&Datei"), datei );
menuBar()->insertItem( i18n("&Bearbeiten"), bearbeiten );
menuBar()->insertItem( i18n("&Verbindung"), verbindung );
menuBar()->insertItem( i18n("&Hilfe"), hilfe );

}

void PMC::createToolBar() {

toolBar();

toolBar()->insertButton( Icon("disconnected.xpm"), 1, SIGNAL( clicked()), this,
												 SLOT( tryConnect()), true, i18n("Mailbox connecten") );

toolBar()->insertButton( Icon("connected.xpm"), 2, SIGNAL( clicked()), this,
												 SLOT( sendQuit2Box() ), true, i18n("Mailbox disconnecten") );

toolBar()->setItemEnabled( 2, false );

toolBar()->insertSeparator();

toolBar()->insertButton( Icon("filemail.xpm"), 3, SIGNAL( clicked()), this,
												 SLOT( writeMail() ), true, "Neue Nachricht" );

toolBar()->setItemEnabled( 3, false );

toolBar()->insertButton( Icon("filefloppy.xpm"), 4, SIGNAL( clicked()), this,
												 SLOT( saveToFile()), true, "Nachricht speichern" );

toolBar()->setItemEnabled( 4, false );

toolBar()->insertButton( Icon("fileprint.xpm"), 5, SIGNAL( clicked()), this,
												 SLOT( printEditorText()), true, i18n("Nachricht ausdrucken") );

toolBar()->setItemEnabled( 5, false );

toolBar()->insertSeparator();

toolBar()->insertButton( Icon("checkmail.xpm"), 6, SIGNAL( clicked()), this,
												 SLOT( checkMail()), true, "Mailcheck" );

toolBar()->setItemEnabled( 6, false );

toolBar()->insertButton( Icon("filereply.xpm"), 7, SIGNAL( clicked()), this,
												 SLOT( writeAnswerToAbsender()), true, "Antworten" );

toolBar()->setItemEnabled( 7, false );

toolBar()->insertButton( Icon("filereplyall.xpm"), 8, SIGNAL( clicked()), this,
												 SLOT( writeAnswerToRubrik()), true, i18n("Antwort in die Rubrik") );

toolBar()->setItemEnabled( 8, false );

toolBar()->insertButton( Icon("filedel2.xpm"), 9, SIGNAL( clicked()), this,
												 SLOT( deleteMail()), true, i18n("Nachricht lschen") );

toolBar()->setItemEnabled( 9, false );

toolBar()->insertButton( Icon("page.xpm"), 10, SIGNAL( clicked()), this,
												 SLOT( openAdressBook()), true, i18n("Adrebuch") );

toolBar()->setItemEnabled( 10, false );

connectContext = new QPopupMenu();

connectContext->insertItem( i18n("&Quit"), this, SLOT(sendQuit2Box()) );
connectContext->insertItem( i18n("&Bye"), this, SLOT(sendBye2Box()) );
connectContext->insertSeparator();
connectContext->insertItem( i18n("&Disconnect"), this, SLOT( tryDisconnect()) );

toolBar()->setDelayedPopup( 2, connectContext );
}


void PMC::createStatusBar() {

statusBar();
statusBar()->setInsertOrder( KStatusBar::RightToLeft );
statusBar()->insertItem( "Welcome to PMC by DG2YLP", 1 );

}


void PMC::tryConnect() {

ax25 = new AX25();

int fd;

if ( secondConnect == false )
	fd = ax25->createSocket(daten->AX25myCall, daten->ax25Port, daten->ax25Path, daten->destCall, false);
else
	fd = ax25->createSocket(daten->AX25myCall, daten->ax25Port, daten->ax25Path, daten->destCall, true);	

ax25->createConnect();

QString tmp = i18n("Try to connect to ");
tmp.append( daten->destCall );

statusBar()->changeItem( tmp, 1 );

notify = new QSocketNotifier( fd, QSocketNotifier::Read, this );

QObject::connect( notify, SIGNAL(activated(int)), ax25, SLOT(readDat(int)));
QObject::connect( ax25, SIGNAL(connectionLost()), this, SLOT(tryDisconnect()));
QObject::connect( ax25, SIGNAL(confirmConnect()), this, SLOT(slotConfirmConnect()));

// Zeitintensiv!!! ->

if (debugMode == true ) cout << "daten->passwordActive " << daten->passwordActive << "\n";

if ( daten->passwordActive == true ) {

	if (debugMode == true ) cout << "daten->passwordActive-IF\n" << "\n";

// damit password nach dem passwort-string suchen kann..
	QObject::connect( ax25, SIGNAL( RXLineData(QString)),	passW, SLOT( trace4Password(QString)));
// damit ax25 nach der passwort bestaetigung die restlichen kommando's senden kann..
	QObject::connect( passW, SIGNAL( sendRemindingCmds()), ax25, SLOT( sendFirstCmds()));
// damit password was auf den kanal senden kann..
	QObject::connect( passW, SIGNAL( sendToBox(QString)),	ax25, SLOT( writeDat(QString)));

}

}

void PMC::slotConfirmConnect() {

rubrikListView->clear();

conOrDisc( true );

QObject::connect( ax25, SIGNAL( RXLineData(QString)),
									rubrikListView, SLOT( incomingLine(QString)));

QObject::connect( ax25, SIGNAL( RXLineData(QString)), 	// Damit der Editor nach einer Mail gucken kann
									edit, SLOT( parseForMail(QString)));

QObject::connect( edit, SIGNAL( sendString( QString )),	// Talk wird in edit realisiert bzw. erstellt
									ax25, SLOT( writeDat( QString )));

QObject::connect( mailListView, SIGNAL( sendString( QString ) ),
									ax25, SLOT( writeDat( QString ) ) );

if ( daten->sevenPlusActive )

	QObject::connect( ax25, SIGNAL( RXLineData( QString ) ),
										sPlus, SLOT( parse_line_4_7plusHeader( QString ) ) );

	QObject::connect( ax25, SIGNAL( RXRawData( char *, int ) ),
										aBin, SLOT( rxData( char *, int ) ) );

/*
if (debugMode == true ) cout << "daten->passwordActive " << daten->passwordActive << "\n";

if ( daten->passwordActive == true ) {

	password *passW = new password();

if (debugMode == true ) cout << "daten->passwordActive-IF\n" << "\n";

// damit password nach dem passwort-string suchen kann..
	QObject::connect( ax25, SIGNAL( RXLineData(QString)),	passW, SLOT( trace4Password(QString)));
// damit ax25 nach der passwort bestaetigung die restlichen kommando's senden kann..
	QObject::connect( passW, SIGNAL( sendRemindingCmds()), ax25, SLOT( sendFirstCmds()));
// damit password was auf den kanal senden kann..
	QObject::connect( passW, SIGNAL( sendToBox(QString)),	ax25, SLOT( writeDat(QString)));

}
*/
}


void PMC::sendQuit2Box() {

ax25->writeDat( "quit\n" );		// hier kann man eventl. eine globale var. setzen, es ist mir aber keine box bekannt welche
															// nicht mit q beendet..
changeStatus( 10 );
}

void PMC::sendBye2Box() {

ax25->writeDat( "bye\n" );		// hier kann man eventl. eine globale var. setzen, es ist mir aber keine box bekannt welche
															// nicht mit q beendet..
changeStatus( 11 );
}


void PMC::tryDisconnect() {

delete ax25;
secondConnect=true;
delete notify;

conOrDisc( false );
}

void PMC::conOrDisc( bool cstate ) {

int z;

QString tmp;

if ( cstate == true ) {

	changeStatus( 1 );	// Verbindung vorhanden
	toolBar()->setItemEnabled( 1, false );

	verbindung->removeItemAt( 0 );
	verbindung->insertItem( "&Disconnect", this, SLOT( sendQuit2Box()), CTRL + Key_D );	

	for (	z=2; z<=10; z++ ) {
		if( z != 9 ) //das delete icon soll nicht sofort aktiviert werden..
			toolBar()->setItemEnabled( z, true );
	}

}
else {

	changeStatus( 0 );	// verbindung getrennt
	toolBar()->setItemEnabled( 1, true );

	verbindung->removeItemAt( 0 );
	verbindung->insertItem( "&Connect", this, SLOT( tryConnect()), CTRL + Key_C );	

	for (	z=2; z<=10; z++ ) {
		toolBar()->setItemEnabled( z, false );
	}
  daten->connectState = false;
}
}


// diese Funktion veraendert die Status-Anzeige des Hauptfensters .. sie ist nahezu mit allen
// anderen klassen( objekten ) verbunden damit sie den Status fuer den User Sichtbar machen koennen
void PMC::changeStatus( int state ) {

QString tmp;

switch( state ) {

case 0:			//disconnected
	tmp = i18n("disconnected from ");
	tmp.append( daten->destCall);

	statusBar()->changeItem( tmp, 1 );
	break;

case 1:			//connected
	tmp = i18n("connected to ");
	tmp.append( daten->destCall);

	statusBar()->changeItem( tmp, 1 );
	break;

case 2:			//check-liste empfangen
	statusBar()->changeItem(i18n ( "Die Check-Mail-Liste wird empfangen" ), 1 );
	break;

case 3:			//list-Liste empfangen
	statusBar()->changeItem(i18n ( "Die List-Mail-Liste wird empfangen" ), 1 );
	break;

case 4:			//Mail wird empfangen
	statusBar()->changeItem(i18n ( "Mailempfang" ), 1 );
	break;

case 5:			//wenn der Read-Befehl gesendet wurde
	statusBar()->changeItem( i18n ( "Nachricht wird angefordert!" ), 1 );
	break;

case 6:
	statusBar()->changeItem( i18n ( "Nachricht wird versendet" ), 1 );
	break;

case 7:
	statusBar()->message( i18n("Mail wurde erfolgreich versendet"), 4000 );
	killMailWidget();
	break;

case 8:
	statusBar()->changeItem( i18n("Mail wird gelscht"), 1 );
	break;

case 9:
	statusBar()->message( i18n("Mail wurde erfolgreich gelscht"), 4000 );
	break;

case 10:
	statusBar()->changeItem( i18n("Das Quit-Kommando wird gesendet"), 1 );
	break;

case 11:
	statusBar()->changeItem( i18n("Das Bye-Kommando wird gesendet"), 1 );
	break;

case 12:
	statusBar()->changeItem( i18n("7Plus-File wird empfangen"), 1 );
	break;

case 13:
	statusBar()->changeItem( i18n("AutoBin-File wird empfangen"), 1);
	break;
}

}


// icon mit "id" mit "newStatus" neu einstellen (false = deaktivieren)
void PMC::enableToolIcon( int id, bool newStatus ) {

toolBar()->setItemEnabled( id, newStatus );
}



void PMC::deleteMail() {

QString sndTmp= "e ";
sndTmp.append( mailListView->currentMailRubrik );
sndTmp.append( " " );
sndTmp.append( mailListView->currentMailNr );
sndTmp.append( "\n" );

QString tmp = i18n("Soll die folgende Nachricht aus ihrem Postfach gelscht werden?\n\n");

tmp.append("Absender: ");
tmp.append( mailListView->currentAbsender );
tmp.append( "\n" );
tmp.append( "Betreff: ");
tmp.append( mailListView->currentTitle );

switch( QMessageBox::information( this, "PMC", tmp, i18n("Ja"), i18n("Nein"), 0, 1 ) ) {

	case 0: ax25->writeDat( sndTmp );
					toolBar()->setItemEnabled( 9, false );
					changeStatus( 8 );
					mailListView->setMailStatus( 3 );
					break;
	case 1: cout << "NEIN!\n";
}
	
}


void PMC::openAdressBook() {

new adressBook;
}


void PMC::openSetup() {

new configDlg();
}

void PMC::openSearch()
{
	findDlg *findDialog = new findDlg();
	searchConnections( findDialog );
}

void PMC::searchConnections( findDlg *find )
{
	QObject::connect( find, SIGNAL(sendString(QString)), this, SLOT(prepareForBoxSearch(QString)));
	QObject::connect( find, SIGNAL(mailSearch(bool)), edit, SLOT(searchEngine(bool)));
}

void PMC::saveToFile() {

QString editorText = edit->text();
QString saveFile = QFileDialog::getSaveFileName( QDir::homeDirPath() );

if ( saveFile != NULL ) {

	QFile file( saveFile );

	if( file.exists() ) {
		switch (
			QMessageBox::information( this, "PMC", i18n("Das File existiert bereits!\nberschreiben?"),i18n("Ja"),i18n("Nein"),0,1 )
			) {
				case 0:
					if ( file.open( IO_WriteOnly ) ) {
						file.writeBlock( editorText, editorText.length() );
				  }
				  else {
						QMessageBox::information( this, "PMC", i18n("PMC kann das File nicht anlegen :(") );	
					}
				  break;
				case 1: cout << "PMC: no File stored!\n";
			}
	}
	else {

		if ( file.open( IO_WriteOnly ) ) {
			file.writeBlock( editorText, editorText.length() );
	  }
	  else {
			QMessageBox::information( this, "PMC", i18n("PMC kann das File nicht anlegen :(") );	
		}	
	}

}
}


//mail-text drucken...
//diese funktion druckt jeweils 69 Zeilen pro seite aus (courier 10)...
//leider ist die schrift fest gesetzt da ich sonst nicht weiss wann ich
//eine neue seite anfangen soll, das kann QPrinter leider nicht automatisch :(
void PMC::printEditorText() {

int z, siteCount, z2, z3;

z = 0;

QString editorText = edit->text();

QString site;


QPrinter prt;
if ( prt.setup() ) {
	QPainter p;

	z = editorText.contains( "\n" );

	if ( z > 69 ) {

		siteCount = z / 69;

		for( z2=0; z2<siteCount; z2++ ) {

			site=NULL;
			
			for( z3=0; z3<69; z3++ ) {

				site.append( editorText.left( editorText.find("\n") +1) );
				editorText.remove( 0, editorText.find("\n") +1 );
			}	

			z = z -69;

			p.begin( &prt );
			p.setFont( QFont("courier", 10 ) );  //feste groesse damit der seitenwechsel passt (muss leider sein :( )
		  p.drawText( 10, 30, 100, 100, AlignLeft|AlignTop|DontClip, site );
			p.end();

//			prt.newPage();    	
		}				
	}			


	p.begin( &prt );
	p.setFont( QFont("courier", 10 ) );  //feste groesse damit der seitenwechsel passt (muss leider sein :( )
  p.drawText( 10, 30, 100, 100, AlignLeft|AlignTop|DontClip, editorText );
	p.end();


}
}


// wenn der mailCheck button gedrueckt wurde, wird das daten->checkComand gesendet...
void PMC::checkMail() {

rubrikListView->clear();

QString tmp = daten->checkComand;

while( tmp.find(";") != -1 )
	tmp.replace( tmp.find(";"), 1, "\n" );

if( tmp.right( 1 ) != "\n" )
	tmp.append("\n");


ax25->writeDat( tmp );

}



void PMC::writeMail() {

mailWriteWidget *mWW = new mailWriteWidget(this, "0", "0", "0", "0", false );

writeMailConnects( mWW );
}


void PMC::prepareForBoxSearch( QString str )
{
	if( daten->connectState )
	{
		ax25->writeDat( str );
		rubrikListView->clear();
	}
}


void PMC::writeAnswerToRubrik() {

mailWriteWidget *mWW = new mailWriteWidget(this, mailListView->currentRubrik,
																						mailListView->currentTitle, edit->text(), mailListView->currentVerteiler, true );

writeMailConnects( mWW );
}



void PMC::writeAnswerToAbsender() {

mailWriteWidget *mWW = new mailWriteWidget(this, mailListView->currentAbsender,
																						mailListView->currentTitle, edit->text(), mailListView->currentVerteiler, false );

writeMailConnects( mWW );
}



//hier werden die noetigen verbindungen erstellt welche das mailWriteWidget braucht..
void PMC::writeMailConnects( mailWriteWidget *mWW ) {

QObject::connect( mWW, SIGNAL(sendMailToNet(QString)), ax25, SLOT(writeToBuffer( QString ) ));
QObject::connect( mWW, SIGNAL(emitStatus(int)), this, SLOT( changeStatus(int)));
QObject::connect( this, SIGNAL(killMailWidget()), mWW, SLOT( killMe()));
}


void PMC::killMe() {

if( daten->connectState == true ) {
	switch ( QMessageBox::information( this, "PMC", i18n("Sie sind noch mit der Mailbox verbunden!
Mchten Sie trotzdem PMC beenden?"), i18n("Ja"), i18n("Nein"), 0, 1 ) ) {

	case 0: daten->xMainCoord = width();
					daten->yMainCoord = height();
					daten->speicher_daten();
					app->quit();
					break;
	case 1: break;
	}
}
else {
	daten->xMainCoord = width();
	daten->yMainCoord = height();
	daten->speicher_daten();
	app->quit();
}

}

void PMC::closeEvent( QCloseEvent *ce ) {

ce->ignore();
killMe();
}

