/***************************************************************************
                          pmc.h  -  description
                             -------------------
    begin                : Thu Jun 29 15:30:04 CEST 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PMC_H
#define PMC_H

#include <kapp.h>
#include <qwidget.h>
#include <ktmainwindow.h>
#include <qpopupmenu.h>
#include <kiconloader.h>
#include <qsocketnotifier.h>
#include <qfiledialog.h>
#include <qsplitter.h>


#include "network.h"
#include "lviews.h"
#include "editors.h"
#include "password.h"
#include "download.h"
#include "dialogs.h"

class PMC : public KTMainWindow
{
  Q_OBJECT 

  public:
    /** construtor */
    PMC();
    /** destructor */
    ~PMC();


	public slots:
		void createMenuBar();
		void createToolBar();
		void createStatusBar();
		void tryConnect();
		void slotConfirmConnect();
		void tryDisconnect();
		void conOrDisc( bool );
		void changeStatus( int );
		void writeMail();
		void writeAnswerToRubrik();
		void writeAnswerToAbsender();
		void enableToolIcon( int, bool );
		void deleteMail();
		void openAdressBook();
		void openSetup();
		void closeEvent( QCloseEvent * );
		void sendQuit2Box();
		void sendBye2Box();
		void prepareForBoxSearch( QString );
		void openSearch();

	private slots:
		void writeMailConnects( mailWriteWidget *);
		void searchConnections( findDlg *);
		void saveToFile();
		void checkMail();
		void printEditorText();
		void killMe();

	private:
		QPopupMenu *datei, *bearbeiten, *verbindung;
		QPopupMenu *connectContext;
		AX25 *ax25;
		QSocketNotifier *notify;
		outputEdit *edit;
		password *passW;
		siebenPlus *sPlus;
		autoBin *aBin;
		rubrikView *rubrikListView;
		mailView *mailListView;
		QSplitter *split1, *split2;
		bool secondConnect;

	signals:
		void killMailWidget();
};

#endif
