/***************************************************************************
                          sPlusDownWin.cpp  -  description
                             -------------------
    begin                : Sun Mar 5 2000
    copyright            : (C) 2000 by Philipp Lensing
    email                : maniac@squishers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "stdio.h"
#include "sPlusDownWin.h"

#include <kapp.h>

sPlusDownWin::sPlusDownWin(QWidget *parent, QString File, long Size,
													 QString parts ) : QWidget () {

ourDad = parent;

fileSize = Size;

setCaption( File );

setMaximumSize (300, 180);
setMinimumSize (300, 50);

time1 = new QTime();
time1->start();

progress = new QProgressBar( Size, this, "download");

progress->move(20,20);
progress->resize(260, 20);

QFrame *forText = new QFrame(this );
forText->setGeometry(20, 40, 150, 180);

QFrame *forCPS = new QFrame(this);
forCPS->setGeometry(150, 50, 210, 70);

QFrame *forBaud = new QFrame(this);
forBaud->setGeometry(150, 70, 210, 90);

QFrame *forBytes = new QFrame(this);
forBytes->setGeometry(150, 90, 210, 110);

QFrame *forTime = new QFrame(this);
forTime->setGeometry(150, 110, 210, 130);

QFrame *forFrag = new QFrame(this);
forFrag->setGeometry(150, 130, 210, 150);

QLabel *cpstxt = new QLabel( "CPS :", forText);
cpstxt2 = new QLabel ( "0", forCPS );
cpstxt->move(0,10);
cpstxt2->setAlignment( AlignRight | AlignVCenter | ExpandTabs );

QLabel *baudtxt = new QLabel( "bits/sec :", forText);
baudtxt2 = new QLabel ( "0", forBaud );
baudtxt->move(0,30);
baudtxt2->setAlignment( AlignRight | AlignVCenter | ExpandTabs );

QLabel *rbytes = new QLabel( "received bytes :", forText );
rbytes2 = new QLabel ( "", forBytes );
rbytes->move(0, 50);
rbytes2->setAlignment( AlignRight | AlignVCenter | ExpandTabs );

QLabel *startat = new QLabel( "time :", forText );
startat->move(0, 70);

startat2 = new QLabel( "0:0:0", forTime );
startat2->setAlignment( AlignRight | AlignVCenter | ExpandTabs );

QLabel *fragtxt = new QLabel( "7+ File :", forText);
fragtxt->move(0, 90 );

frag = new QLabel( parts, forFrag );
frag->setAlignment( AlignRight | AlignVCenter | ExpandTabs );


interval = new QTimer ();
interval->start( 1000, false);
QObject::connect( interval, SIGNAL(timeout()), this, SLOT(berechne_cps_baud()) );


show();
}



void sPlusDownWin::berechne_cps_baud() {

char msgtmp[8];

float bdtmp;

if( time1->elapsed() > 1000 && zbytescpy < fileSize )
{


char strtmp3[4];

long leftTime = time1->elapsed();

int leftHours;
leftHours = leftTime / 3600000;

sprintf( strtmp3,"%i:", leftHours );
QString newTime = strtmp3;

int leftMins;
leftMins = (leftTime % 3600000) / 60000;

sprintf( strtmp3, "%i:", leftMins );
newTime.append( strtmp3 );

int leftSecs;
leftSecs = ((leftTime % 3600000) % 60000) / 1000;

sprintf( strtmp3, "%i", leftSecs );
newTime.append( strtmp3 );


startat2->setText( newTime );

float timtmp = time1->elapsed() / 1000;

bdtmp = (float) zbytescpy / timtmp ;

int bdtmp1 = (int) bdtmp;

int bdtmp2 = int (bdtmp1) * 8;

sprintf(msgtmp, "%i", int (bdtmp1) );
cpstxt2->setText( msgtmp );

sprintf(msgtmp, "%i", bdtmp2 );

baudtxt2->setText( msgtmp );
}
else {
}

}





void sPlusDownWin::downloadBytes( long zbytes ) {

char sizetemp[10];

zbytescpy = zbytes;

sprintf(sizetemp, "%li/", zbytes);

QString helpme = sizetemp;

sprintf(sizetemp, "%li", fileSize);

helpme.append( sizetemp );

rbytes2->setText( helpme );

progress->setProgress( zbytes );

}


void sPlusDownWin::getPart( QString currentPart, long Size ) {

progress->reset();

fileSize = Size;

time1->restart();

frag->setText( currentPart );
}


void sPlusDownWin::closeEvent( QCloseEvent *cev ) {

switch( QMessageBox::warning( this, "PMC",
				    i18n( "Wollen Sie wirklich den Download abbrechen?\n\n"),
				    i18n("Ja"), i18n("Nein"), 0, 1 ) )
{
case 0: downloadAborted(); delete this;
break;

case 1: cev->ignore();
break;
}
}

void sPlusDownWin::killMe() {
downloadFinished();
delete this;
}
